
let _NCC_Shopify_Theme_Name = "";
let _NCC_Shopify_Theme_Schema_Name = "";
let _NCC_Shopify_Theme_Store_id = "";
let _NCC_Shopify_Theme_id = "";
let _NCC_Shopify_Shop = "";
let __n_td = new Date();
let __show_date = new Date(__n_td.getFullYear(), __n_td.getMonth(), 1);
let _before_Checkout_Click_Closing = -1;
let _before_Checkout_Click_Date = "";
let _unable_date = [];
function NGCGetShopifyThemeName() {
  try {
    _NCC_Shopify_Theme_Name = Shopify.theme.name;
    _NCC_Shopify_Theme_Schema_Name = Shopify.theme.schema_name;
    _NCC_Shopify_Theme_Store_id = Shopify.theme.theme_store_id;
    _NCC_Shopify_Theme_id = Shopify.theme.id;
    _NCC_Shopify_Shop = Shopify.shop;
  } catch (error) {}
}
NGCGetShopifyThemeName();
let _NCC_Shopify_HOST = location.hostname;

function NGCCompareTimeFunc(t) {
  let t1 = new Date();
  let t2 = new Date();
  if (/^[0-5][0-9]:[0-5][0-9]$/.test(t)) {
    let hour_mins = t.split(":");
    let hour = hour_mins[0];
    let mins = hour_mins[1];
    t2.setHours(Number(hour));
    t2.setMinutes(Number(mins));
    if (t2 > t1) {
      return 0;
    }
  }
  return 1;
}

function NGCHaisouAreaChange(v) {
  let ar = document.getElementsByClassName("ngc_haisou_area");
  let ds = document.getElementsByClassName("_NGC_CFA_shippingdate_select");
  for (let a = 0; a < ar.length; a++) {
    if (ds[a]) {
      ds[a].value = "希望なし";
    }
    ar[a].value = v;
  }

}

function NGCGETHAISOUAREA(minDays) {
  let s = {
    'd1': null,
    'a1': "",
    'd2': null,
    'a2': "",
    'd3': null,
    'a3': "",
    'd4': null,
    'a4': "",
    'd5': null,
    'a5': "",
  }
  let longest = minDays;
  for (let a = 1; a <= 5; a++) {
    let l = 'd' + a;
    if (!isNaN(s[l])) {
      if (s[l] > longest) {
        longest = s[l];
      }
    }
  }
  let ar = document.getElementsByClassName("ngc_haisou_area");
  if (ar[0]) {
    if (ar[0].value == '') {
      return minDays;
    }
    for (let a = 1; a <= 5; a++) {
      let l = 'd' + a;
      let m = 'a' + a;
      let as = s[m].split(',');
      if (as.indexOf(ar[0].value) != -1) {
        return s[l];
      }
    }
  }
  return minDays;
}

function NGCCreateDisabledDates(closing, minDays, maxDays, nonBusinessDates, nonBusinessDays, bannedDates, bannedDays) {
  const fd = (date, format) => {
    format = format.replace(/yyyy/g, date.getFullYear());
    format = format.replace(/MM/g, ('0' + (date.getMonth() + 1)).slice(-2));
    format = format.replace(/dd/g, ('0' + date.getDate()).slice(-2));
    format = format.replace(/HH/g, ('0' + date.getHours()).slice(-2));
    format = format.replace(/mm/g, ('0' + date.getMinutes()).slice(-2));
    format = format.replace(/ss/g, ('0' + date.getSeconds()).slice(-2));
    format = format.replace(/SSS/g, ('00' + date.getMilliseconds()).slice(-3));
    return format;
  };
  let td = new Date();
  let d = [];
  nonBusinessDates = nonBusinessDates.split(',');
  nonBusinessDays = nonBusinessDays.split(',');
  bannedDates = bannedDates.split(',');
  bannedDays = bannedDays.split(',');
  for (let i = 0; i < minDays; i++) {
    let td1 = new Date(td);
    td1 = fd(new Date(td1.setDate(td1.getDate() + i)), 'yyyy/MM/dd');
    if (i == 0 && closing == 1 && nonBusinessDates.indexOf(td1) == -1) {
      nonBusinessDates.push(td1);
    } else if (d.indexOf(td1) === -1) {
      d.push(td1);
    }
  }
  let c = 0;
  let noneContinue = true;
  for (let i = 0; i <= maxDays; i++) {
    let f = fd(new Date(td), 'yyyy/MM/dd');
    if (noneContinue == true && (nonBusinessDates.indexOf(f) !== -1 || nonBusinessDays.indexOf(String((new Date(f)).getDay())) !== -1)) {
      if (d.indexOf(f) === -1) {
        d.push(f);
      }
      c++;
    } else if (noneContinue == true && (nonBusinessDates.indexOf(f) === -1 && nonBusinessDays.indexOf(String((new Date(f)).getDay())) === -1)) {
      for (let a = 0; a < minDays; a++) {
        let td1 = new Date(td);
        td1 = fd(new Date(td1.setDate(td1.getDate() + a)), 'yyyy/MM/dd');
        if (d.indexOf(td1) === -1) {
          d.push(td1);
        }
      }
      noneContinue = false;
    }
    if (bannedDates.indexOf(f) != -1 || bannedDays.indexOf(String((new Date(f)).getDay())) != -1) {
      if (d.indexOf(f) === -1) {
        d.push(f);
      }
    }
    td.setDate(td.getDate() + 1);
  }
  d = d.join(',');
  return d;
}
_NGC_CFA_Ajax = function () {
  this.initialize = function () {
    this.xhr = new XMLHttpRequest();
  };
  this.post = function (url, data, success = function () {}, fail = function () {}) {
    this.xhr.onreadystatechange = function () {
      if (this.readyState == XMLHttpRequest.DONE) {
        if (this.status == 200) {
          success(this);
        } else {
          fail(this);
        }
      }
    };
    this.xhr.open("POST", url);
    this.xhr.setRequestHeader("Content-Type", "application/json");
    this.xhr.send(JSON.stringify(data));
  };
  this.getJSON = function (url, success = function () {}, fail = function () {}) {
    this.xhr.onreadystatechange = function () {
      if (this.readyState == XMLHttpRequest.DONE) {
        if (this.status == 200) {
          success(JSON.parse(this.responseText));
        } else {
          fail(this);
        }
      }
    };
    this.xhr.open("GET", url);
    this.xhr.send();
  };
  this.initialize();
};
_NGC_CFA_Ajax = new _NGC_CFA_Ajax();
async function _n_getCart() {
  return new Promise(async function (resolve, reject) {
    await _NGC_CFA_Ajax.getJSON('https://' + _NCC_Shopify_HOST + '/cart.js', async function (d) {
      return resolve(d);
    });
  });
}

async function _n_getCart_fetch() {
  return new Promise(async function (resolve, reject) {
    _NGC_CFA_Ajax_Fetch.getJSON('https://' + _NCC_Shopify_HOST + '/cart.js', resolve, reject)
  });
}

_NGC_CFA_Ajax_new = function () {
  this.initialize = function () {
    this.xhr = new XMLHttpRequest();
  };

  this.post = function (url, data, success = function () {}, fail = function () {}) {
    this.xhr.onreadystatechange = () => {
      if (this.xhr.readyState === 4) {
        if (this.xhr.status === 200) {
          success(this.xhr);
        } else {
          fail(this.xhr);
        }
      }
    };
    this.xhr.open("POST", url);
    this.xhr.setRequestHeader("Content-Type", "application/json");
    this.xhr.send(JSON.stringify(data));
  };

  this.getJSON = function (url, success = function () {}, fail = function () {}) {
    this.xhr.onreadystatechange = () => {
      if (this.xhr.readyState === 4) {
        if (this.xhr.status === 200) {
          success(JSON.parse(this.xhr.responseText));
        } else {
          fail(this.xhr);
        }
      }
    };
    this.xhr.open("GET", url);
    this.xhr.send();
  };

  this.initialize();
};

_NGC_CFA_Ajax_new = new _NGC_CFA_Ajax_new();

_NGC_CFA_Ajax_Fetch = function () {
  this.initialize = function () {
  };
  
  this.post = function (url, data, success = function () {}, fail = function () {}) {
    fetch(url, {
      method: 'POST',
      headers: {
        'Content-Type': 'application/json'
      },
      body: JSON.stringify(data)
    })
    .then(response => {
      if (response.ok) {
        return response.json();
      } else {
        throw new Error('Network response was not ok');
      }
    })
    .then(json => success(json))  
    .catch(error => fail(error)); 
  };

  this.getJSON = function (url, success = function () {}, fail = function () {}) {
    fetch(url, {
      method: "GET",
      headers: {
        "Content-Type": "application/json"
      }
    })
      .then(response => {
        if (!response.ok) {
          throw new Error("Network response was not ok");
        }
        return response.json();
      })
      .then(json => success(json))
      .catch(error => fail(error));
  };

  this.initialize();
};

_NGC_CFA_Ajax_Fetch = new _NGC_CFA_Ajax_Fetch();

async function _n_getCart_new() {
  return new Promise((resolve, reject) => {
    _NGC_CFA_Ajax_new.getJSON(
      'https://' + _NCC_Shopify_HOST + '/cart.js',
      (data) => {
        resolve(data);
      },
      (error) => {
        reject(error);
      }
    );
  });
}

async function _n_getTags(t, item) {
  return new Promise(async function (resolve, reject) {
    if (item['handle']) {
      await _NGC_CFA_Ajax.getJSON('https://' + _NCC_Shopify_HOST + '/products/' + item['handle'] + '.js', async function (p) {
        if (p['tags']) {
          for (let j = 0; j < p['tags'].length; j++) {
            t.push(p['tags'][j]);
          }
        }
        return resolve(t);
      });
    }
  });
}

async function _n_getTags_fetch(t, item) {
  return new Promise((resolve, reject) => {
    if (item['handle']) {
      _NGC_CFA_Ajax_Fetch.getJSON(
        'https://' + _NCC_Shopify_HOST + '/products/' + item['handle'] + '.js',
        function (p) {
          if (p['tags']) {
            for (let j = 0; j < p['tags'].length; j++) {
              t.push(p['tags'][j]);
            }
          }
          resolve(t);
        },
        function (error) {
          console.error("商品tagsの取得が失败:", error);
          reject(error);
        }
      );
    } else {
      resolve(t); 
    }
  });
}

async function _n_getTags_new(t, item) {
  return new Promise(async function (resolve, reject) {
    if (item['handle']) {
      await _NGC_CFA_Ajax_new.getJSON('https://' + _NCC_Shopify_HOST + '/products/' + item['handle'] + '.js', async function (p) {
        if (p['tags']) {
          for (let j = 0; j < p['tags'].length; j++) {
            t.push(p['tags'][j]);
          }
        }
        return resolve(t);
      });
    }
  });
}


async function resetNGCCARTATTR(attr) {
  return new Promise(async function (resolve, reject) {
    try {
      let attributes = {};
      for (const key in attr) {
        if (attr[key]) {
          attributes[key] = '';
        }
      }
      await _NGC_CFA_Ajax_Fetch.post('https://' + _NCC_Shopify_HOST + '/cart/update.js', {attributes: attributes});
      return resolve();
    } catch (error) {
      return resolve();
    }
  });
}
async function ngcCartInit(attribute) {
  let ts = (new Date()).getTime();
  let lts = localStorage.getItem('ngccartts');
  localStorage.setItem('ngccartts', ts);
  if (isNaN(lts)) {
    await resetNGCCARTATTR(attribute);
    return;
  }
  lts = Number(lts);
  let isReset = false;
  try {
    if ((new Date(ts)).getFullYear() != (new Date(lts)).getFullYear() || (new Date(ts)).getMonth() != (new Date(lts)).getMonth() || (new Date(ts)).getDate() != (new Date(lts)).getDate()) {
      isReset = true;
    }
  } catch (error) { isReset = true; }
  if (isReset === true) {
    await resetNGCCARTATTR(attribute);
    return;
  }
  for (let key in attribute) {
    let els = document.getElementsByName('attributes[' + key + ']');
    for (let a = 0; a < els.length; a++) {
      if (els[a]['tagName'] == "INPUT") {
        if (els[a]['type'] == "text" || els[a]['type'] == "hidden") {
          els[a].value = attribute[key];
        } else if (els[a]['type'] == "checkbox") {
          let cs = attribute[key].split(',');
          for (let b = 0; b < cs.length; b++) {
            if (els[a].value == cs[b]) {
              els[a].checked = true;
            }
          }
        } else if (els[a]['type'] == "radio") {
          if (els[a].value == attribute[key]) {
            els[a].checked = true;
          }
        }
      } else if (els[a]['tagName'] == "TEXTAREA") {
        els[a].value = attribute[key];
      } else if (els[a]['tagName'] == "SELECT") {
        let options = els[a].options;
        for (let b = 0; b < options.length; b++) {
          if (options[b].value == attribute[key]) {
            options[b].selected = true;
          }
        }
      }
    }
  }
}
async function createNGCCartHTMLScrip(cart_item) {
  return new Promise(async function (resolve, reject) {
    const NOTEHTML = "{{cart}}";
    let NGCHTMLSHIPPING = "";
    let NGCHTMLSHIPPINGDATE = `<div class="ngc-note-attr-field"><label>配送希望日</label><input onclick="NGCOpenCalendar();" onchange="event.stopPropagation(); updateNGCCartAttributes(this)" type='text' class="_NGC_CFA_shippingdate_select _NGC_CFA_note_field" autocomplete='off' name='attributes[配送希望日]' readonly='true' value ='希望なし' /><p id='shippingDateResetMsg' style="color:red;display:none">配送締め時刻を過ぎているため、再度配送日を選択してください。</p></div>`;
    let NGCHTMLSHIPPINGTIME = `<div class="ngc-note-attr-field"><label>配送希望時間</label><select onchange="event.stopPropagation(); updateNGCCartAttributes(this)" class="_NGC_CFA_shippingtime_select _NGC_CFA_note_field" name='attributes[配送希望時間]'><option value ='希望しない'>希望しない</option><option value ='0812'>午前中</option><option value ='1416'>14~16時</option><option value ='1618'>16~18時</option><option value ='1820'>18~20時</option><option value ='1921'>19~21時</option></select></div>`;

    let t = [];
    for (let i = 0; i < cart_item.length; i++) {
      if(_NCC_Shopify_Shop == "gorillasquad.myshopify.com"){
        t = await _n_getTags_new(t, cart_item[i]);
      }
      else if(_NCC_Shopify_Shop == "demo-esuelleom.myshopify.com"){
        t = await _n_getTags_fetch(t, cart_item[i]);
      }
      else{
        t = await _n_getTags(t, cart_item[i]);
      }
    }
    if (t.indexOf("配送日時指定対象外") != -1) {
      NGCHTMLSHIPPINGDATE = "";
      NGCHTMLSHIPPINGTIME = "";
    }
    if (t.indexOf("配送日付指定対象外") != -1) {
      NGCHTMLSHIPPINGDATE = "";
    }
    if (t.indexOf("配送時間指定対象外") != -1) {
      NGCHTMLSHIPPINGTIME = "";
    }
    if (t.indexOf("配送日時指定対象外") != -1 || (t.indexOf("配送日付指定対象外") != -1 && t.indexOf("配送時間指定対象外") != -1)) {
      NGCHTMLSHIPPING = '<div class="non-shipping-text" style="margin: 20px 0 0 auto;max-width: 300px;font-size:12px;">' + `配送日時指定対象外の商品が入っているため、配送日時を指定できません。` + '</div>';
    }
    NGCHTMLSHIPPING = NGCHTMLSHIPPINGDATE + NGCHTMLSHIPPINGTIME + NGCHTMLSHIPPING;
    let NGCIsShippingActivate = false;
    if (NGCIsShippingActivate == true) {
      return resolve(NGCHTMLSHIPPING);
    } else {
      NGCHTMLSHIPPINGDATE = `<div class="ngc-note-attr-field"><label>配送希望日</label><input onclick="NGCOpenCalendar();" onchange="event.stopPropagation(); updateNGCCartAttributes(this)" type='text' class="_NGC_CFA_shippingdate_select _NGC_CFA_note_field" autocomplete='off' name='attributes[配送希望日]' readonly='true' value ='希望なし' /><p id='shippingDateResetMsg' style="color:red;display:none">配送締め時刻を過ぎているため、再度配送日を選択してください。</p></div>`;
      NGCHTMLSHIPPINGTIME = `<div class="ngc-note-attr-field"><label>配送希望時間</label><select onchange="event.stopPropagation(); updateNGCCartAttributes(this)" class="_NGC_CFA_shippingtime_select _NGC_CFA_note_field" name='attributes[配送希望時間]'><option value ='希望しない'>希望しない</option><option value ='0812'>午前中</option><option value ='1416'>14~16時</option><option value ='1618'>16~18時</option><option value ='1820'>18~20時</option><option value ='1921'>19~21時</option></select></div>`;
      
      // Bareminerals Customized
      if(_NCC_Shopify_Theme_id == '157645832478' || _NCC_Shopify_Theme_Name.includes('Bare-minerals')){
        if(NGCHTMLSHIPPINGDATE){
          NGCHTMLSHIPPINGDATE = NGCHTMLSHIPPINGDATE.replace('<label>配送エリア</label>', '<label>配送エリア  ※選択必須</label>');
        }
        if(NGCHTMLSHIPPINGTIME){
          NGCHTMLSHIPPINGTIME = NGCHTMLSHIPPINGTIME.replace('>希望しない</option>', '>希望なし</option>');
        }
      }
    
      NGCHTMLSHIPPING = NGCHTMLSHIPPINGDATE + NGCHTMLSHIPPINGTIME;
      return resolve(NGCHTMLSHIPPING);
    }
  });
}
async function createNGCCartField(NHTMLSCRIPT) {
  return new Promise(async function (resolve, reject) {
    let t1 = [ "Dawn", "Sense", "Ride", "Colorblock", "Taste", "Studio", "Craft", "Crave"];
    let d = document.createElement('div');
    d.innerHTML = NHTMLSCRIPT;
    let p = location.pathname;
    if (document.getElementById("_NGC_CFA")) {
      document.getElementById("_NGC_CFA").appendChild(d);
    } else if ((t1.indexOf(_NCC_Shopify_Theme_Name) != -1 && document.getElementById("cart")) || document.getElementById("cart") && _NCC_Shopify_Theme_Name != "Local" && _NCC_Shopify_Theme_Name != "Xtra" && _NCC_Shopify_Theme_Name != "Combine" && ! _NCC_Shopify_Theme_Name.includes('Megashop-home1')
      && _NCC_Shopify_Theme_Store_id != '568' && _NCC_Shopify_Theme_Store_id != '1657' && _NCC_Shopify_Shop != "ouji-shop.myshopify.com" && _NCC_Shopify_Theme_Schema_Name !="Parallax" && _NCC_Shopify_Theme_Schema_Name !="Rise") {
      document.getElementById("cart").appendChild(d);
    } else if (_NCC_Shopify_Theme_Store_id == '1657') {
      if(location.pathname.startsWith("/cart")){
        if(document.querySelector('#cart-summary')){
          document.querySelector('#cart-summary').insertAdjacentHTML('afterbegin', NHTMLSCRIPT);
        }
      }
      else{
        if(document.querySelector('#cart-drawer') && document.querySelector('#cart-drawer').children[2]){
          document.querySelector('#cart-drawer').children[2].insertAdjacentHTML('afterbegin', NHTMLSCRIPT);
        }
      }
      let n = document.createElement('style');
      n.type = 'text/css';
      n.innerText = '.ngc-note-attr-field {margin-bottom: 20px !important;}';
      document.getElementsByTagName('HEAD').item(0).appendChild(n);
    } else if ((_NCC_Shopify_Theme_Name.includes('Warehouse') && document.querySelector(".cart-recap__notices")) || document.querySelector(".cart-recap__notices")) {
      document.querySelector(".cart-recap__notices").insertAdjacentHTML('beforebegin', NHTMLSCRIPT);
    } else if(_NCC_Shopify_Theme_Name.includes('Xtra') && document.querySelector(".b50") || document.querySelector(".b50")){
      document.getElementsByClassName("form-group")[13].insertAdjacentHTML('beforebegin', NHTMLSCRIPT);
    } else if(_NCC_Shopify_Theme_Name.includes('Megashop-home') && location.pathname.startsWith("/cart")){
      document.getElementById("main-cart-footer").insertAdjacentHTML('afterend', NHTMLSCRIPT);
      if(document.getElementsByClassName("pe-0 pe-lg-4 is-empty").length == 1){
        for(i=0;i<document.getElementsByClassName("ngc-note-attr-field").length;i++){
          document.getElementsByClassName("ngc-note-attr-field")[i].remove();
        }
      }
      for(j=0;j<document.getElementsByClassName("ngc-note-attr-field").length;j++){
        document.getElementsByClassName("ngc-note-attr-field")[j].addEventListener('change',function(e){ 
          e.stopPropagation();
        })
      }
      document.querySelector('.js-contents').addEventListener('DOMSubtreeModified',()=>{
        if(document.getElementsByClassName("js-contents")[0].textContent == ''){
          for(k=0;k<document.getElementsByClassName("ngc-note-attr-field").length;k++){
            document.getElementsByClassName("ngc-note-attr-field")[k].setAttribute('style','display:none');
          } 
        }else{
          for(k=0;k<document.getElementsByClassName("ngc-note-attr-field").length;k++){
            document.getElementsByClassName("ngc-note-attr-field")[k].setAttribute('style','display:block');
          } 
        }
      })
    } else if(_NCC_Shopify_Theme_Name.includes('North') && document.querySelector('.thb-cart-form-container') && document.querySelector('.cart-empty') == null){
      document.getElementsByClassName("cart-collaterals")[0].insertAdjacentHTML('beforebegin', NHTMLSCRIPT);
    } else if (_NCC_Shopify_Theme_Name.includes('Combine') && document.querySelector("#AjaxCartSubtotal")){
      if(p.startsWith("/cart")){
        document.getElementById("AjaxCartSubtotal").insertAdjacentHTML('beforebegin', NHTMLSCRIPT);
        document.getElementById("AjaxCartSubtotal").setAttribute('style','margin-top:5% !important;');
      }
    } else if(_NCC_Shopify_Theme_Name.includes('Motion')){
      if (p.startsWith("/cart")) {
        document.getElementsByClassName("grid")[0].insertAdjacentHTML('beforebegin', NHTMLSCRIPT);
        let n = document.createElement('style');
        n.type = 'text/css';
        n.innerText = '.ngc-note-attr-field {margin: 0 !important;margin-left: 55% !important; }';
        document.getElementsByClassName("grid")[0].setAttribute('style','margin-top:50px');
        document.getElementsByTagName('HEAD').item(0).appendChild(n);
      }
    } else if(_NCC_Shopify_Theme_Name.includes('Pipeline') && document.querySelector(".drawer__body")){
      document.getElementsByClassName("drawer__body")[0].insertAdjacentHTML('afterend', NHTMLSCRIPT);
      let n = document.createElement('style');
      n.type = 'text/css';
      n.innerText = '.ngc-note-attr-field {margin: 0 !important;margin-left: 5% !important; }';
      document.getElementsByTagName('HEAD').item(0).appendChild(n);
    } else if(_NCC_Shopify_Theme_Name.includes('Empire') && document.querySelector('.cart-subtotal')){
      document.getElementsByClassName("cart-subtotal")[0].insertAdjacentHTML('beforebegin', NHTMLSCRIPT);
    } else if(_NCC_Shopify_Theme_Name.includes('Flow') && document.querySelector('.right-drawer-vue')){
      if(p.startsWith("/cart")){
        document.getElementsByClassName("grid cart__row")[0].insertAdjacentHTML('beforebegin',NHTMLSCRIPT);        
        let n = document.createElement('style');
        n.type = 'text/css';
        n.innerText = '.cart--button-checkout, .cart--button-update{transition:none !important; }';
        document.getElementsByTagName('HEAD').item(0).appendChild(n);
      }
      document.getElementsByClassName("right-drawer-vue")[0].addEventListener("transitionend",function(e){
        if(document.getElementsByClassName("ajaxcart__footer-wrapper")[0] && document.getElementsByClassName("ngc-note-attr-field").length == 0 && document.getElementsByClassName("non-shipping-text").length == 0){
          let n = document.createElement('style');
          n.type = 'text/css';
          n.innerText = '.drawer__close button:after {transition:none !important; }.drawer__close button:before{transition:none !important; }.cart__checkout{transition:none !important; }';
          document.getElementsByTagName('HEAD').item(0).appendChild(n);
          document.getElementsByClassName("ajaxcart__footer-wrapper")[0].insertAdjacentHTML('beforebegin',NHTMLSCRIPT);
          document.getElementsByClassName("cart__checkout")[0].setAttribute("id","checkout");
          document.getElementById('checkout').addEventListener('click',function(e){ 
            let fileds = document.getElementsByClassName('_NGC_CFA_note_field');
            for (let a = 0; a < fileds.length; a++) {
              const item = fileds[a];
              if (document.getElementById('checknull_'+item.id)) {
                let filedsTag = item.tagName;
                let filedsType = item.type;
                let filedsValue = item.value;
                let filedsName = item.name;
                let isNullOrNot = document.getElementById('checknull_'+item.id).value;
                let errMessage = document.getElementById('errMessage_'+item.id).value;
                if ((filedsTag == "INPUT" && filedsType == "text") || filedsTag == "TEXTAREA" || filedsTag == "SELECT") {
                  if((filedsValue == '' || filedsValue == '選択なし') && isNullOrNot == 'must' && errMessage !=''){
                    e.preventDefault();
                    document.getElementById('displayerrMessage_'+item.id).innerHTML= errMessage;
                  }else{
                    document.getElementById('displayerrMessage_'+item.id).innerHTML='';
                  }
                }
                if ((filedsTag == "INPUT" && filedsType == "radio") || (filedsTag == "INPUT" && filedsType == "checkbox")) {
                  let els = Array.from(document.getElementsByName(filedsName));
                  let rs = els.filter(el => el.checked == true);
                  if(isNullOrNot == 'must' && errMessage !='' && rs.length == 0){
                    e.preventDefault();      
                    document.getElementById('displayerrMessage_'+item.id).innerHTML= errMessage;
                  }else{
                    document.getElementById('displayerrMessage_'+item.id).innerHTML='';
                  }
                }
              }
            }
            checkDateAviliableBeforeClickingCheckOut(e);
          })
        }        
      });
    } else if(_NCC_Shopify_Theme_Name.includes('Yuva') && document.querySelector(".yv-side-drawer-container")){
      document.querySelector('.yv-side-drawer-container').addEventListener('DOMSubtreeModified',()=>{
        if(document.getElementsByClassName('cart-items-wrapper')[0] && document.getElementsByClassName("ngc-note-attr-field").length == 0){
          document.getElementsByClassName("cart-items-wrapper")[0].insertAdjacentHTML('afterend', NHTMLSCRIPT);
          document.getElementsByClassName("checkout-btn button black-btn")[0].setAttribute('id','checkout');
          document.getElementById("checkout").addEventListener('click',function(e){ 
            let fileds = document.getElementsByClassName('_NGC_CFA_note_field');
            for (let a = 0; a < fileds.length; a++) {
              const item = fileds[a];
              if (document.getElementById('checknull_'+item.id)) {
                let filedsTag = item.tagName;
                let filedsType = item.type;
                let filedsValue = item.value;
                let filedsName = item.name;
                let isNullOrNot = document.getElementById('checknull_'+item.id).value;
                let errMessage = document.getElementById('errMessage_'+item.id).value;
                if ((filedsTag == "INPUT" && filedsType == "text") || filedsTag == "TEXTAREA" || filedsTag == "SELECT") {
                  if((filedsValue == '' || filedsValue == '選択なし') && isNullOrNot == 'must' && errMessage !=''){
                    e.preventDefault();
                    document.getElementsByClassName('errMessageClass_'+item.id)[0].innerHTML= errMessage;
                  }else{
                    document.getElementsByClassName('errMessageClass_'+item.id)[0].innerHTML='';
                  }
                }
                if ((filedsTag == "INPUT" && filedsType == "radio") || (filedsTag == "INPUT" && filedsType == "checkbox")) {
                  let els = Array.from(document.getElementsByName(filedsName));
                  let rs = els.filter(el => el.checked == true);
                  if(isNullOrNot == 'must' && errMessage !='' && rs.length == 0){
                    e.preventDefault();      
                    document.getElementsByClassName('errMessageClass_'+item.id)[0].innerHTML= errMessage;
                  }else{
                    document.getElementsByClassName('errMessageClass_'+item.id)[0].innerHTML='';
                  }
                }
              }
            }
          })
          let n = document.createElement('style');
          n.type = 'text/css';
          n.innerText = '.cart-items-wrapper{height:30% !important; }';
          document.getElementsByTagName('HEAD').item(0).appendChild(n);
        }
       })
    } else if (_NCC_Shopify_Theme_Schema_Name.includes('Expanse') && (document.querySelector(".cart__scrollable") || document.querySelector('form#CartPageForm[action="/cart"][data-location="page"]'))) {
      if(document.querySelector(".cart__scrollable")){
          document.querySelector(".cart__scrollable").appendChild(d);
      }else{
          document.querySelector('form#CartPageForm[action="/cart"][data-location="page"]').appendChild(d);
      }
    } else if (_NCC_Shopify_Theme_Name.includes('Venue') && document.querySelector(".cart__footer")) {
      document.querySelector(".cart__footer").insertAdjacentHTML('beforebegin', NHTMLSCRIPT);
    }else if ((_NCC_Shopify_Theme_Name.includes('Showcase') && document.querySelector(".note-area")) || document.querySelector(".note-area")) {
      document.querySelector(".note-area").insertAdjacentHTML('beforebegin', NHTMLSCRIPT);
      let n = document.createElement('style');
      n.type = 'text/css';
      n.innerText = '.ngc-note-attr-field {margin: 0 auto !important}';
      document.getElementsByTagName('HEAD').item(0).appendChild(n);
    } else if (_NCC_Shopify_Theme_Name.includes('Symmetry') && document.querySelector(".checkout-subtotal-container__dynamic")) {
      document.querySelector(".checkout-subtotal-container__dynamic").prepend(d);
    } else if (_NCC_Shopify_Theme_Name.includes('Symmetry') && p.startsWith("/cart") && document.querySelector(".checkout-subtotal-container")) {
      document.querySelector(".checkout-subtotal-container").prepend(d);
    }  else if ((_NCC_Shopify_Theme_Name.includes('Broadcast') && (document.querySelector(".cart__total") || document.querySelector(".form-cart"))) || (document.querySelector(".cart__total") || document.querySelector(".form-cart"))) {
      if (p.startsWith("/cart")) {
        document.getElementsByClassName('cart__total')[0].insertAdjacentHTML('beforebegin', NHTMLSCRIPT);
      } else if (document.getElementsByClassName('form-cart')[0]) {
        document.getElementsByClassName('form-cart')[0].prepend(d);
      }
    } else if ((_NCC_Shopify_Theme_Name.includes('Boost') && document.querySelector(".cart-finish")) || document.querySelector(".cart-finish")) {
      document.querySelector(".cart-finish").insertAdjacentHTML('beforebegin', NHTMLSCRIPT);
    } else if(_NCC_Shopify_Theme_Name.includes('Spark') && document.querySelector('.cart__footer')){
      if (p.startsWith("/cart")) {
        document.getElementsByClassName('cart__footer')[0].insertAdjacentHTML('afterbegin', NHTMLSCRIPT); 
        document.getElementsByClassName('cart__footer')[0].setAttribute('style','display:block !important; padding-top: 0 !important');  
        document.getElementsByClassName('cart__footer-left')[0].setAttribute('style','width:100% !important'); 
        document.getElementsByClassName('cart__footer-right')[0].setAttribute('style','width:100% !important');   
      } 
    } else if(_NCC_Shopify_Theme_Name.includes('Focal') && _NCC_Shopify_HOST ==="f-room.shop"){
      if (p.startsWith("/cart")) {
        document.getElementsByClassName("cart__recap-block")[0].insertAdjacentHTML('beforebegin', NHTMLSCRIPT); 
        if(document.getElementsByClassName("ngc-note-attr-field").length > 0){
          document.getElementsByClassName("ngc-note-attr-field")[document.getElementsByClassName("ngc-note-attr-field").length - 1].setAttribute('style','margin-bottom:20px !important');
        }
      } 
    } else if(_NCC_Shopify_Theme_Name.includes('Story') && document.getElementsByClassName("cart__items")[0]){
      if (p.startsWith("/cart")) {
        document.getElementsByClassName("cart__items")[0].insertAdjacentHTML('beforeend', NHTMLSCRIPT); 
        if(document.getElementsByClassName("ngc-note-attr-field").length > 0){
          document.getElementsByClassName("ngc-note-attr-field")[document.getElementsByClassName("ngc-note-attr-field").length - 1].setAttribute('style','margin-bottom:20px !important');
        }
      } 
    } else if(_NCC_Shopify_Theme_Name.includes('Envy') && document.querySelector(".cart-totals--wrapper")){
      if (p.startsWith("/cart")) {
        document.querySelector(".cart-totals--wrapper").insertAdjacentHTML('afterend', NHTMLSCRIPT); 
      } 
    } else if(_NCC_Shopify_Theme_Schema_Name.includes('Impulse') && document.querySelector('.cart__item-row.cart__checkout-wrapper')){
      if (p.startsWith("/cart")) {
        document.querySelector('.cart__item-row.cart__checkout-wrapper').insertAdjacentHTML('beforeBegin', NHTMLSCRIPT);
      } 
    } else if((_NCC_Shopify_Theme_Name.includes('Vision') || _NCC_Shopify_Theme_Store_id == '2053') && document.querySelector('.proceed-to-checkout')){
      if (p.startsWith("/cart")) {
        document.querySelector('.proceed-to-checkout').insertAdjacentHTML('beforeBegin', NHTMLSCRIPT);
      } 
    } else if((_NCC_Shopify_Theme_Name.includes('Debut') ||_NCC_Shopify_Theme_Store_id == '796') && document.querySelector('.cart__footer')){
        document.querySelector('.cart__footer').insertAdjacentHTML('beforeBegin', NHTMLSCRIPT);
    } else if((_NCC_Shopify_Theme_Name.includes('Habitat') ||_NCC_Shopify_Theme_Store_id == '1581') && document.querySelector('.proceed-to-checkout')){
        document.querySelector('.proceed-to-checkout').insertAdjacentHTML('afterBegin', NHTMLSCRIPT);
        document.querySelector('._NGC_CFA_shippingtime_select ').setAttribute('style','padding:0 10px !important'); 
        document.querySelectorAll('._NGC_CFA_shippingtime_select').forEach(element => {
            element.setAttribute('style', 'padding:0 10px !important');
        });
    } else if((_NCC_Shopify_Theme_Schema_Name == "Parallax") && document.querySelector('.add-to-cart-wrap')){
        document.querySelector('.add-to-cart-wrap').insertAdjacentHTML('beforeBegin', NHTMLSCRIPT);
    } else if(_NCC_Shopify_Theme_Schema_Name == "Expression"){
        const button = document.querySelector('button[type="submit"].btn.btn--primary.cart-checkout-button[name="checkout"]');
        if (button) {
          const parentDiv = button.closest('div'); 
          if (parentDiv) {
              parentDiv.insertAdjacentHTML('beforebegin', NHTMLSCRIPT);
          }
        }
    } else if(_NCC_Shopify_Theme_Schema_Name == "Prestige"){
      const target = document.querySelector('.Cart__Recap');
      if (target){
        target.insertAdjacentHTML('afterbegin', NHTMLSCRIPT);
        const checkoutButton = document.querySelector('#checkout');
        if (checkoutButton) {
            checkoutButton.disabled = false;
        }
      }
    } else if(_NCC_Shopify_Theme_Schema_Name == "Blum"){
      if (p.startsWith("/cart") && document.querySelector('#cartForm')) {
        document.querySelector('#cartForm').appendChild(d);
      }
    } else if(_NCC_Shopify_Theme_Schema_Name == "Rise"){
     const target = document.querySelector('form#cart');
      if (target) {
        target.appendChild(d);
      }
    } else {
      if (document.querySelector(".update-cart")) {
        document.querySelector(".update-cart").insertAdjacentHTML('beforebegin', NHTMLSCRIPT);
      } else if (document.querySelector(".cart-drawer__content")) {
        document.querySelector(".cart-drawer__content").appendChild(d);
      } else if (document.querySelector(".cart-finish")) {
        document.querySelector(".cart-finish").insertAdjacentHTML('beforebegin', NHTMLSCRIPT);
      }
    }
    return resolve();
  });
}
async function createNGCCartDrawerField(NHTMLSCRIPT) {
  return new Promise(async function (resolve, reject) {
    let ne = document.createElement('div');
    ne.id = '_NGC_CART_DRAWER';
    let d = document.createElement('div');
    d.innerHTML = NHTMLSCRIPT;
    let p = location.pathname;
    if ((_NCC_Shopify_Theme_Name.includes('Blockshop') && (document.querySelector(".cart--totals") || document.querySelector(".cart--notes"))) || (document.querySelector(".cart--totals") || document.querySelector(".cart--notes"))) {
      if (p.startsWith("/cart")) {
        let els = document.getElementsByClassName('cart--totals');
        els[0].appendChild(ne);
        for (let a = 0; a < els.length; a++) {
          let dd = document.createElement('div');
          dd.innerHTML = NHTMLSCRIPT;
          els[a].prepend(dd);
        }
      } else {
        document.getElementsByClassName('cart--notes')[0].appendChild(ne);
        document.getElementsByClassName('cart--notes')[0].appendChild(d);
      }
    }else if(_NCC_Shopify_Theme_Name.includes('Venue') && document.querySelector(".cart__content")){
      if (document.getElementsByClassName('cart-empty').length==1){
          return resolve(false);
      }
    }else if (_NCC_Shopify_Theme_Schema_Name == 'Prestige' || _NCC_Shopify_Theme_Store_id == '855') {
      if (p.startsWith("/cart") || p.startsWith("/en/cart")) {
        if(document.querySelector('.cart-page') && !document.querySelector("#_NGC_CFA") && !document.querySelector("._NGC_CFA_note_field")){
          document.getElementsByClassName('cart-footer')[0].appendChild(ne);
          document.getElementsByClassName('cart-recap')[0].insertAdjacentHTML('afterbegin', NHTMLSCRIPT);
          document.getElementsByClassName("cart-page")[0].setAttribute('style','row-gap:0 !important');
          let n = document.createElement('style');
          n.type = 'text/css';
          n.innerText = '.ngc-note-attr-field {margin: 0 0 0 0 !important; max-width: 200px !important; all: inherit;}';
          document.getElementsByTagName('HEAD').item(0).appendChild(n);
          if(document.getElementsByClassName("shipping-estimator")[0]){
            document.getElementsByClassName("shipping-estimator")[0].setAttribute('style','margin-top:50px');
          }
          const checkoutButton = document.querySelector('#checkout');
          if (checkoutButton) {
              checkoutButton.disabled = false;
          }
        }
        if(_NCC_Shopify_Shop ==='32264f-4.myshopify.com'){
          const checkoutButton = document.querySelector('button#checkout[type="submit"]');
            if (checkoutButton) {
                checkoutButton.disabled = false;
            }
        }
      }
      else{
        if(_NCC_Shopify_Shop != "2b4f30-c0.myshopify.com"){
          var targetElement = document.querySelector('.cart-drawer__footer .button-group');
          if(targetElement && targetElement.classList.length === 1 && !document.querySelector('.ngc-note-attr-field')){
            targetElement.insertAdjacentHTML('beforebegin', NHTMLSCRIPT);
            let n = document.createElement('style');
            n.type = 'text/css';
            n.innerText = '.ngc-note-attr-field {margin: 0 !important}';
            document.getElementsByTagName('HEAD').item(0).appendChild(n);
          }else if(document.getElementsByClassName('Cart__Checkout')[0] && !document.querySelector('.ngc-note-attr-field')){
            document.getElementsByClassName('Cart__Checkout')[0].insertAdjacentHTML('beforebegin', NHTMLSCRIPT);
            let n = document.createElement('style');
            n.type = 'text/css';
            n.innerText = '.ngc-note-attr-field {margin: 0 !important}';
            document.getElementsByTagName('HEAD').item(0).appendChild(n);
          }
        }
      }
    } else if (_NCC_Shopify_Theme_Schema_Name.includes('Impulse')) {
      if (p.startsWith("/cart")) {
        if(document.querySelector('.cart__item-row.cart__checkout-wrapper')){
          if(!document.querySelector('.cart__item-row.cart__checkout-wrapper').parentElement.querySelector('.ngc-note-attr-field')){
            document.querySelector('.cart__item-row.cart__checkout-wrapper').insertAdjacentHTML('beforeBegin', NHTMLSCRIPT);
          } 
        }   
      }
      else{
       if(document.querySelector('.cart__checkout-wrapper') && !document.querySelector('.ngc-note-attr-field')){
          document.querySelector('.cart__checkout-wrapper').insertAdjacentHTML('beforeBegin', "<div id='_NGC_CART_DRAWER'></div>");
          document.querySelector('.cart__checkout-wrapper').insertAdjacentHTML('beforeBegin', NHTMLSCRIPT);
        }
      }
    } else if (_NCC_Shopify_Theme_Name.includes('Pipeline') && document.querySelector(".cart__items")) {
      if (p.startsWith("/cart")) {
        document.getElementsByClassName("cart__items")[0].appendChild(ne);
        document.getElementsByClassName("cart__items")[0].appendChild(d);
      }
    } else if (_NCC_Shopify_Theme_Name.includes('Yuva') && document.querySelector(".cart__items")) {
      if (p.startsWith("/cart")) {
        document.getElementsByClassName("cart__items")[0].appendChild(ne);
        document.getElementsByClassName("cart__items")[0].appendChild(d);
      }
    } else if (_NCC_Shopify_Theme_Name.includes('Lorenza') && document.querySelector(".cart-template__items")) {
      if (p.startsWith("/cart")) {
        document.getElementsByClassName("cart-template__items")[0].appendChild(ne);
        document.getElementsByClassName("cart-template__items")[0].appendChild(d);
      }
    } else if (_NCC_Shopify_Theme_Name.includes('Supply') && document.querySelector(".cart-subtotal")) {
      if (p.startsWith("/cart")) {
        return resolve(false);
      } else {
        document.getElementsByClassName('cart-subtotal')[0].appendChild(ne);
        document.getElementsByClassName('cart-subtotal')[0].insertAdjacentHTML('beforebegin', NHTMLSCRIPT);
      }
    } else if (_NCC_Shopify_Theme_Name.includes('Stiletto') && (document.querySelector(".quick-cart__items") || document.querySelector(".cart__form-items"))) {
      if (p.startsWith("/cart")) {
        document.getElementsByClassName('cart__form-items')[0].appendChild(ne);
        document.getElementsByClassName('cart__form-items')[0].appendChild(d);
      } else {
        document.getElementsByClassName('quick-cart__items')[0].appendChild(ne);
        document.getElementsByClassName('quick-cart__items')[0].appendChild(d);
      }
    } else if (_NCC_Shopify_Theme_Name.includes('Spark') && document.querySelector(".quick-cart__items")) {
        if(!document.getElementsByClassName("quick_cart__empty ff-body fs-body-base visible")[0] && !p.startsWith("/cart")){
          document.getElementsByClassName('quick-cart__total')[0].appendChild(ne);
          document.getElementsByClassName('quick-cart__total')[0].appendChild(d);
          let ngcNote = document.getElementsByClassName("ngc-note-attr-field");
          for(i=0;i<ngcNote.length;i++){
            ngcNote[i].childNodes.item(0).setAttribute('style','color:#fff !important');
          }
          for(j=0;j<ngcNote.length;j++){
            ngcNote[j].childNodes.item(1).setAttribute('style','background-color:#fff !important');
          }
          let n = document.createElement('style');
          n.type = 'text/css';
          n.innerText = '.ngc-note-attr-field {text-align: left !important; min-width: 300px !important;}';
          document.getElementsByTagName('HEAD').item(0).appendChild(n);
        }      
    } else if ((_NCC_Shopify_Theme_Name.includes('Testament') && (document.querySelector(".ajax-cart__final-details") || document.querySelector('.ajax-cart__info-wrapper'))) || (document.querySelector(".ajax-cart__final-details") || document.querySelector('.ajax-cart__info-wrapper'))) {
      let newStyle = document.createElement('style');
      newStyle.type = 'text/css';
      newStyle.innerText = '.ngc-note-attr-field label, .ngc-note-attr-field span, .ngc-note-attr-field {font-size: 14px !important}';
      document.getElementsByTagName('HEAD').item(0).appendChild(newStyle);
      if (p.startsWith("/cart")) {
        document.getElementsByClassName('ajax-cart__final-details')[0].appendChild(ne);
        document.getElementsByClassName('ajax-cart__final-details')[0].prepend(d);
      } else {
        document.getElementsByClassName('ajax-cart__info-wrapper')[0].appendChild(ne);
        document.getElementsByClassName('ajax-cart__info-wrapper')[0].prepend(d);
      }
    } else if (_NCC_Shopify_Theme_Name.includes('Focal') && (document.querySelector(".cart__content") || document.querySelector("#mini-cart-form"))) {
      if(_NCC_Shopify_HOST !=="f-room.shop"){
        if (p.startsWith("/cart")) {
          document.getElementsByClassName('cart__content')[0].appendChild(ne);
          document.getElementsByClassName('cart__content')[0].appendChild(d);
        } else {
          document.getElementById('mini-cart-form').appendChild(ne);
          document.getElementById('mini-cart-form').appendChild(d);
        }
      }
    } else if (_NCC_Shopify_Theme_Name.includes('North') && document.querySelector('.widget_shopping_cart_content')){
      document.getElementsByClassName('mini-cart')[0].appendChild(ne);
      document.getElementsByClassName('mini-cart')[0].appendChild(d);      
    } else if ((_NCC_Shopify_Theme_Name.includes('Refresh') && document.querySelector("#CartDrawer-CartItems")) || document.querySelector("#CartDrawer-CartItems")) {
      if (!p.startsWith("/cart")) {
        document.getElementById('CartDrawer-CartItems').appendChild(ne);
        document.getElementById('CartDrawer-CartItems').appendChild(d);
      }
    } else if((_NCC_Shopify_Theme_Name.includes('Local') && document.querySelector(".cart-form")) || document.querySelector(".cart-form")){
      if (p.startsWith("/cart")) {
        document.getElementById('AjaxCartForm').appendChild(ne);
        document.getElementById('AjaxCartForm').appendChild(d);
      }else if(document.getElementsByClassName("cart-is-empty").length==0 && !p.startsWith("/all")){
        document.getElementById('AjaxCartForm').appendChild(ne);
        document.getElementById('AjaxCartForm').appendChild(d);
      }
    } else if((_NCC_Shopify_Theme_Name.includes('Be Yours') || _NCC_Shopify_Theme_Store_id == '1399')&& document.querySelector('.mini-cart__footer .subtotal')){
      let parent = document.querySelector('.mini-cart__footer .subtotal').parentNode;
      let target = document.querySelector('.mini-cart__footer .subtotal');
      parent.insertBefore(ne, target);
      parent.insertBefore(d, target);
    } else if((_NCC_Shopify_Theme_Name.includes('Story'))){
      if (p.startsWith("/cart") && document.querySelector(".cart__items")) {
        if (document.getElementsByClassName('ngc-note-attr-field').length == 0) {
          document.getElementsByClassName("cart__items")[0].insertAdjacentHTML('beforeend', NHTMLSCRIPT); 
        }
        else{
          document.getElementsByClassName("ngc-note-attr-field")[document.getElementsByClassName("ngc-note-attr-field").length - 1].setAttribute('style','margin-bottom:20px !important');
        }
      }else if(document.getElementsByClassName("cart__items").length > 1){
        if (document.getElementsByClassName('ngc-note-attr-field').length == 0) {
          document.getElementsByClassName("cart__items")[1].insertAdjacentHTML('afterend', NHTMLSCRIPT);
        }else{
          for(i = 0; i <= document.getElementsByClassName('ngc-note-attr-field').length; i++){
            document.getElementsByClassName('ngc-note-attr-field')[i].setAttribute('style','margin-right:3% !important');
          }
        }
      }

    } else if((_NCC_Shopify_Theme_Name.includes('Envy') && document.querySelector(".cart-items"))){
      if (document.getElementsByClassName('ngc-note-attr-field').length == 0) {
        document.querySelector(".cart-items").insertAdjacentHTML('beforeend', NHTMLSCRIPT);
        if(document.querySelector('._NGC_CFA_shippingtime_select')){
          document.querySelector('._NGC_CFA_shippingtime_select').setAttribute('style','width:193px !important');
        }
      }
    }else if((_NCC_Shopify_Theme_Name.includes('Flow') && document.querySelector(".ajaxcart__inner"))){
      let cart_obj = await _n_getCart();
      let NGCHTMLSCRIPTNEW = await createNGCCartHTMLScrip(cart_obj['items']);
      d.innerHTML = NGCHTMLSCRIPTNEW;
      if(NGCHTMLSCRIPTNEW.indexOf("non-shipping-text") != -1){
        if(document.getElementsByClassName("non-shipping-text").length != 0){
          if(NGCHTMLSCRIPTNEW && document.getElementsByClassName("non-shipping-text").length == 0 &&
            document.getElementsByClassName("ngc-note-attr-field").length == 0){
            let cartinner = document.querySelector(".ajaxcart__inner");
            let cartfooter = document.querySelector(".ajaxcart__footer-wrapper");
            if(cartfooter && cartinner){
              cartinner.insertBefore(d,cartfooter);
            }
          }
          return resolve(false);
        }
        else{
          if(document.querySelectorAll('.ngc-note-attr-field').length != 0){
            var elements = document.querySelectorAll('.ngc-note-attr-field');
            for (var element of elements) {
              element.remove();
            }
          }
          let cartinner = document.querySelector(".ajaxcart__inner");
          let cartfooter = document.querySelector(".ajaxcart__footer-wrapper");
          if(cartfooter && cartinner){
            cartinner.insertBefore(d,cartfooter);
          }
        }
      }
      else{
        if(document.getElementsByClassName("non-shipping-text").length != 0){
          document.getElementsByClassName("non-shipping-text")[0].remove();
          if(document.querySelectorAll('.ngc-note-attr-field').length != 0){
            var elements = document.querySelectorAll('.ngc-note-attr-field');
            for (var element of elements) {
              element.remove();
            }
          }
          let cartinner = document.querySelector(".ajaxcart__inner");
          let cartfooter = document.querySelector(".ajaxcart__footer-wrapper");
          if(cartfooter && cartinner){
            cartinner.insertBefore(d,cartfooter);
          }
        }
        else{
          if(NGCHTMLSCRIPTNEW && document.getElementsByClassName("non-shipping-text").length == 0 &&
            document.getElementsByClassName("ngc-note-attr-field").length == 0){
            let cartinner = document.querySelector(".ajaxcart__inner");
            let cartfooter = document.querySelector(".ajaxcart__footer-wrapper");
            if(cartfooter && cartinner){
              cartinner.insertBefore(d,cartfooter);
            }
          }
          return resolve(false);
        }
      }  
    }
    else if((_NCC_Shopify_Theme_Name.includes('Vision') || _NCC_Shopify_Theme_Store_id == '2053') && document.querySelector('.cart-drawer-buttons')){
      let parent = document.querySelector('.cart-drawer-buttons').parentNode;
      let target = document.querySelector('.cart-drawer-buttons');
      parent.insertBefore(ne, target);
      parent.insertBefore(d, target);
    }
    else if((_NCC_Shopify_Theme_Name.includes('Habitat') ||_NCC_Shopify_Theme_Store_id == '1581') && document.querySelector('.mini-cart__row.mini-cart__total.total')){
        let parent = document.querySelector('.mini-cart__row.mini-cart__total.total').parentNode;
        let target = document.querySelector('.mini-cart__row.mini-cart__total.total');
        parent.insertBefore(ne, target);
        parent.insertBefore(d, target);
        document.querySelectorAll('._NGC_CFA_shippingtime_select').forEach(element => {
            element.setAttribute('style', 'padding:0 10px !important');
        });
    } 
    else if((_NCC_Shopify_Theme_Schema_Name == "Parallax") && document.querySelector('.mm-action_buttons.mm-listitem__text')){
        let parent = document.querySelector('.mm-action_buttons.mm-listitem__text').parentNode;
        let target = document.querySelector('.mm-action_buttons.mm-listitem__text');
        parent.insertBefore(ne, target);
        parent.insertBefore(d, target);
    } 
    else if((_NCC_Shopify_Theme_Schema_Name == "Motion") && document.querySelector('.drawer__footer ')){
      const drawerFooter = document.querySelector('.drawer__footer');
      const firstDivChild = drawerFooter.querySelector('div');
      if (firstDivChild) {
        drawerFooter.insertBefore(ne, firstDivChild);
        drawerFooter.insertBefore(d, firstDivChild);
      } 
    } 
    else if((_NCC_Shopify_Theme_Schema_Name == "Blum") && document.querySelector('#cartDrawer')){
      const drawerFooter = document.querySelector('#cartDrawer').querySelector('.drawer__footer ')
      const firstDivChild = drawerFooter.querySelector('div');
      if (firstDivChild) {
        drawerFooter.insertBefore(ne, firstDivChild);
        drawerFooter.insertBefore(d, firstDivChild);
      } 
    } 
    else {
      if (document.getElementsByClassName('Cart__Checkout')[0]) {
          document.getElementsByClassName('Cart__Checkout')[0].appendChild(ne);
          document.getElementsByClassName('Cart__Checkout')[0].insertAdjacentHTML('beforebegin', NHTMLSCRIPT);     
      } else if (document.getElementById('modal-cart-table')) {
        if (document.getElementsByClassName('cart-total-wrapper')[1]) {
          document.getElementsByClassName('cart-total-wrapper')[1].appendChild(ne);
          document.getElementsByClassName('cart-total-wrapper')[1].insertAdjacentHTML('beforebegin', NHTMLSCRIPT);
        } else if (document.getElementsByClassName('cart-total-wrapper')[0]) {
          document.getElementsByClassName('cart-total-wrapper')[0].appendChild(ne);
          document.getElementsByClassName('cart-total-wrapper')[0].insertAdjacentHTML('beforebegin', NHTMLSCRIPT);
        }
      } else if (document.querySelector(".popup-cart__items")) {
        document.getElementsByClassName('popup-cart__items')[0].appendChild(ne);
        document.getElementsByClassName('popup-cart__items')[0].appendChild(d);
      } 
    }
    return resolve(true);
  });
}
function NGCformatDate(date, format) {
  format = format.replace(/YYYY/g, date.getFullYear());
  format = format.replace(/yyyy/g, date.getFullYear());
  format = format.replace(/MM/g, ('0' + (date.getMonth() + 1)).slice(-2));
  format = format.replace(/dd/g, ('0' + date.getDate()).slice(-2));
  format = format.replace(/DD/g, ('0' + date.getDate()).slice(-2));
  format = format.replace(/HH/g, ('0' + date.getHours()).slice(-2));
  format = format.replace(/hh/g, ('0' + date.getHours()).slice(-2));
  format = format.replace(/mm/g, ('0' + date.getMinutes()).slice(-2));
  format = format.replace(/ss/g, ('0' + date.getSeconds()).slice(-2));
  format = format.replace(/SSS/g, ('00' + date.getMilliseconds()).slice(-3));
  return format;
}

function NGCOpenCalendar() {
  __n_td = new Date();
  if(!document.querySelector('#ngc_haisou_modal')){
    appendNGCCalendarToField()
  }
  NGCShowCalendarProcess(__n_td);
  let els = document.querySelectorAll('.ngc_haisou_td');
  for (let a = 0; a < els.length; a++) {
    els[a].classList.remove('ngc_haisou_selected');
  }
  let fv = document.querySelector('._NGC_CFA_shippingdate_select').value;
  if (!isNaN((new Date(fv)).getTime())) {
    let i = 'ngc_haisou_date-' + NGCformatDate(new Date(fv), "YYYYMMDD");
    if (document.getElementById(i)) {
      document.getElementById(i).classList.add('ngc_haisou_selected');
    }
  }
  document.getElementById('ngc_haisou_modal').classList.remove('ngc_haisou_modal_hide');
}
function NGCCloseCalendar() {
  document.getElementById('ngc_haisou_modal').classList.add('ngc_haisou_modal_hide');
  __show_date = new Date(__n_td.getFullYear(), __n_td.getMonth(), 1);
}
function NGCSelectDate(v) {
  let week = ["日", "月", "火", "水", "木", "金", "土"];
  v = NGCformatDate(new Date(v), "YYYY/MM/DD") + "(" + week[(new Date(v)).getDay()] + ")";

  let els = document.querySelectorAll("._NGC_CFA_shippingdate_select");
  for (let b = 0; b < els.length; b++) {
    els[b].value = v; 
    updateNGCCartAttributes(els[b]);
  }
  document.getElementById('ngc_haisou_modal').classList.add('ngc_haisou_modal_hide');
  __show_date = new Date(__n_td.getFullYear(), __n_td.getMonth(), 1);
}
function NGCResetDateValue() {
  let el = document.querySelectorAll('._NGC_CFA_shippingdate_select');
  for (let a = 0; a < el.length; a++) { 
    el[a].value = '希望なし';
  }
  let n = document.getElementsByName("attributes[open_logi_date]");
  if (n.length > 0) { 
    n[0].value = "";
  }
  let els = document.querySelectorAll("._NGC_CFA_shippingdate_select");
  for (let b = 0; b < els.length; b++) { 
    updateNGCCartAttributes(els[b]);
  }

  document.getElementById('ngc_haisou_modal').classList.add('ngc_haisou_modal_hide');
}
function NGCShowCalendarPrev(){
  __show_date.setMonth(__show_date.getMonth() - 1);
  NGCShowCalendarProcess(__show_date);
}
function NGCShowCalendarNext(){
  __show_date.setMonth(__show_date.getMonth() + 1);
  NGCShowCalendarProcess(__show_date);
}
function NGCShowCalendarProcess(date) {
  let year = date.getFullYear();
  let month = date.getMonth();
  document.querySelector('#ngc_haisou_header').innerHTML = year + "/" + String(month + 1).padStart(2, '0');
  let calendar = NGCCreateCalendarProcess(year, month);
  document.querySelector('#ngc_haisou_calendar').innerHTML = calendar;
}
function NGCCalcDateDiffrence(d1,d2) {
  try {
    d1 = new Date(d1);
    d2 = new Date(d2);
    let date1 = new Date(d1.getFullYear(), d1.getMonth(), d1.getDate());
    let date2 = new Date(d2.getFullYear(), d2.getMonth(), d2.getDate());
    let diff = (date2 - date1) / 86400000;
    return diff;
  } catch (error) {
    return -1
  }
}
function NGCCreateCalendarProcess(year, month) {
  let minDays = 3;
  let shippingDateMin = 3;
  let shippingDateMax = 30;
  let nonBusinessDates = "";
  let nonBusinessDays = "0,6";
  let bannedDates = "";
  let bannedDays = "";
  let shippingCloseTime = "18:00";
  minDays = NGCGETHAISOUAREA(shippingDateMin);
  let closing = NGCCompareTimeFunc(shippingCloseTime);
  _before_Checkout_Click_Closing = closing;
  _before_Checkout_Click_Date = new Date().getMonth().toString() + new Date().getDate().toString();

  let startCountingDate = new Date();
  let todayFormatted = NGCformatDate(startCountingDate, "YYYY/MM/DD");
  let todayIsNonBusinessDay = (nonBusinessDates.indexOf(todayFormatted) !== -1 || nonBusinessDays.indexOf(String(startCountingDate.getDay())) !== -1)
  let nonBusinessDatesRecounting = nonBusinessDates;
  let nonBusinessDaysRecounting = nonBusinessDays;
  let inputMinDays = minDays;
  if (closing === 1 || todayIsNonBusinessDay) {
    nonBusinessDatesRecounting = nonBusinessDatesRecounting.split(',');
    nonBusinessDaysRecounting = nonBusinessDaysRecounting.split(',');
    minDays++;
    shippingDateMax++;
    startCountingDate.setDate(startCountingDate.getDate() + 1);
    let nextAvailableDateWithFormat;
    while (true) {
      nextAvailableDateWithFormat = NGCformatDate(startCountingDate, "YYYY/MM/DD");
      if (nonBusinessDatesRecounting.indexOf(nextAvailableDateWithFormat) === -1 && nonBusinessDaysRecounting.indexOf(String(startCountingDate.getDay())) === -1) {
        break;
      }
      startCountingDate.setDate(startCountingDate.getDate() + 1);
      minDays++;
      shippingDateMax++;
    }
  }
  let diabledDays = NGCCreateDisabledDates(closing, inputMinDays, shippingDateMax, nonBusinessDates, nonBusinessDays, bannedDates, bannedDays);
  diabledDays = diabledDays.split(',');
  _unable_date = diabledDays;

  let week = ["日", "月", "火", "水", "木", "金", "土"];
  let calendar = "<table class='ngc_haisou_table'><tr class='ngc_haisou_dayOfWeek'>";
  for (let i = 0; i < week.length; i++) {
    calendar += "<th class='ngc_haisou_th'>" + week[i] + "</th>";
  }
  calendar += "</tr>";

  let count = 0;
  let startDayOfWeek = new Date(year, month, 1).getDay();
  let endDate = new Date(year, month + 1, 0).getDate();
  let lastMonthEndDate = new Date(year, month, 0).getDate();
  let row = Math.ceil((startDayOfWeek + endDate) / week.length);

  for (let i = 0; i < row; i++) {
    calendar += "<tr>";
    for (let j = 0; j < week.length; j++) {
      if (i == 0 && j < startDayOfWeek) {
        calendar += "<td class='ngc_haisou_td ngc_haisou_disabled'></td>";
      } else if (count >= endDate) {
        count++;
        calendar += "<td class='ngc_haisou_td ngc_haisou_disabled'></td>";
      } else {
        count++;

        let d = NGCformatDate(new Date(year, month, count), "YYYY/MM/DD");
        let di = NGCformatDate(new Date(year, month, count), "YYYYMMDD");
        let diff = NGCCalcDateDiffrence(__n_td,d);

        if (diabledDays.indexOf(d) == -1 && diff >= minDays && diff <= shippingDateMax) {
          calendar += "<td id='ngc_haisou_date-"+ di +"' class='ngc_haisou_td ngc_haisou_td ngc_haisou_selectable' onclick='NGCSelectDate("+ '"' + d + '"' + ");'>" + count + "</td>";
        } else {
          calendar += "<td class='ngc_haisou_td ngc_haisou_disabled'>" + count + "</td>";
        }
      }
    }
    calendar += "</tr>";
  }
  return calendar;
}
function appendNGCCalendarToField() {
  let HTML = '<div onclick="NGCCloseCalendar();" class="ngc_haisou_overlay"></div>';
  HTML += '<div class="ngc_haisou_modal-wrapper">';
  HTML += '<div class="ngc_haisou_modal-contents">';
  HTML += '<div class="ngc_haisou_wrapper">';
  HTML += '<div class="ngc_haisou_top">';
  HTML += '<div id="ngc_haisou_header"></div>';
  HTML += '<div class="ngc_haisou_modal-close" onclick="NGCCloseCalendar();">✕</div>';
  HTML += '</div>';
  HTML += '<div id="ngc_haisou_next-prev-button">';
  HTML += '<button type="button" onclick="NGCShowCalendarPrev();">‹</button>';
  HTML += '<button type="button" onclick="NGCShowCalendarNext();">›</button>';
  HTML += '</div>';
  HTML += '<div id="ngc_haisou_calendar"></div>';
  HTML += '<div id="ngc_haisou_reset-button">';
  HTML += '<button type="button" onclick="NGCResetDateValue();">リセット</button>';
  HTML += '</div>';
  HTML += '</div>';
  HTML += '</div>';
  HTML += '</div>';
  let el = document.createElement('div');
  el.id = "ngc_haisou_modal";
  el.innerHTML = HTML;
  el.classList.add('ngc_haisou_modal');
  el.classList.add('ngc_haisou_modal_hide');
  let p = location.pathname;
  if((_NCC_Shopify_Theme_Name.includes('Be Yours') || _NCC_Shopify_Theme_Schema_Name == 'Prestige')&& document.getElementsByTagName('cart-drawer').length > 0
  && !p.startsWith("/cart")){
    document.getElementsByTagName('cart-drawer').item(0).appendChild(el);
  }else{
    document.getElementsByTagName('BODY').item(0).appendChild(el);
  }
  
}
function appendNGCCSSToField() {
  let newStyle = document.createElement('style');
  newStyle.type = 'text/css';
  let t = ".ngc-note-attr-field {margin: 0 0 0 auto; max-width: 400px;}";
  t += ".ngc-note-attr-field label {display:block; color: #555; margin-top: 30px;}";
  t += ".ngc-note-attr-field input[type='text'] {display: block;width: 100%;height: 45px;color: #555;border: 1px solid #ccc;padding-left: 10px;border-radius: 5px;}";
  t += ".ngc-note-attr-field textarea {display: block;width: 100%;height: 80px;color: #555;border: 1px solid #ccc;padding-left: 10px;border-radius: 5px;}";
  t += ".ngc-note-attr-field select {display: block;width: 100%;height: 45px;color: #555;border: 1px solid #ccc;padding-left: 10px;border-radius: 5px; background-color: #fff;}";

  t += ".ngc_haisou_modal{z-index: 100000000;width: 100%;height: 100%;position: fixed;top: 0;left: 0;}";
  t += ".ngc_haisou_modal_hide {opacity: 0;display: none !important;visibility: hidden !important;transition: opacity 0.5s, visibility 0.5s, display 0.5s;}";
  t += ".ngc_haisou_modal .ngc_haisou_overlay{display: block;width: 100vw;height: 100vh;position: absolute;background-color: #000;opacity: 0.7;top: 0;left: 0;}";
  t += ".ngc_haisou_modal-wrapper{width: 100%;max-width: 650px;min-width: 300px;height: 500px;max-height: 550px;background-color: #fff;position: absolute;top: 50%;left: 50%;transform: translate(-50%, -50%);}";
  t += ".ngc_haisou_modal-contents{overflow: auto;width: 100%;height: 100%;box-sizing: border-box;}";
  t += ".ngc_haisou_wrapper{max-width: 600px;  margin: 0 auto;  color: #666;}";
  t += "@media screen and (max-width: 767px) {.ngc_haisou_wrapper{  max-width: 300px;}}";
  t += ".ngc_haisou_top {position: relative;width: 100%;}";
  t += "#ngc_haisou_header {text-align: center;font-size:24px;width: 100%; margin: 1rem 0 0;font-weight: bolder;}";
  t += ".ngc_haisou_modal-close{color: #555;font-size: 24px;position: absolute;top: 0;right: 20px;text-decoration: none;cursor: pointer;}";
  t += "#ngc_haisou_calendar {  text-align: center;  width: 100%;}";
  t += ".ngc_haisou_table {  outline: 2px solid #ddd;  border-collapse: collapse;  width: 100%;}";
  t += ".ngc_haisou_th { color: #000;}";
  t += ".ngc_haisou_th, .ngc_haisou_td {  outline: 1px solid #ddd;  padding-top: 10px;  padding-bottom: 10px;  text-align: center;}";
  t += ".ngc_haisou_td:first-child {  color: red;}";
  t += ".ngc_haisou_td:last-child {  color: blue;}";
  t += ".ngc_haisou_td.ngc_haisou_disabled {  color: #ccc;}";
  t += ".ngc_haisou_td.ngc_haisou_selectable {cursor: pointer;}";
  t += ".ngc_haisou_td.ngc_haisou_selected {background-color: #D65E72;color: #fff;}";
  t += "#ngc_haisou_next-prev-button {display: flex;justify-content: space-between;}";
  t += "#ngc_haisou_next-prev-button button{  cursor: pointer;  background: #B78D4A;  color: #fff;  border: 1px solid #B78D4A;  border-radius: 4px;  font-size: 1rem;  padding: 0.5rem 2rem;  margin: 1rem 0;width: 70px; height: 36px; font-size: 16px;}";
  t += "#ngc_haisou_next-prev-button button:hover{  background-color: #D4BB92;  border-color: #D4BB92;}";
  t += "#ngc_haisou_reset-button {display: flex;justify-content: end;}";
  t += "#ngc_haisou_reset-button button{cursor: pointer;background: #B78D4A;color: #fff;border: 1px solid #B78D4A;border-radius: 4px;font-size: 1rem;padding: 0.5rem 2rem;margin: 1rem 0;width: 130px;height: 42px;font-size: 14px;}";
  t += "#_NGC_CART_DRAWER {display:none !important;}";
  newStyle.innerText = t;
  document.getElementsByTagName('HEAD').item(0).appendChild(newStyle);
}
const gNGCIsShippingDate = true;
const gNGCIsShippingTime = true;
const gNGCIsShippingActivate = false;
const gNGCIsNextEngine = false;
const gNGCHasCustomField = false;
if(gNGCIsShippingDate == true || gNGCIsShippingTime == true || gNGCIsShippingActivate == true || gNGCIsNextEngine == true || gNGCHasCustomField == true){
  NGCHAISOUCHUMONSUPPORTERINIT();
}
async function NGCHAISOUCHUMONSUPPORTERINIT() {
  
  let cart_obj;
  if(_NCC_Shopify_Shop == "gorillasquad.myshopify.com"){
     cart_obj = await _n_getCart_new();
  }
  else if(_NCC_Shopify_Shop == "demo-esuelleom.myshopify.com"){
    cart_obj = await _n_getCart_fetch();
  }
  else{
     cart_obj = await _n_getCart();
  }
  let NGCHTMLSCRIPT = await createNGCCartHTMLScrip(cart_obj['items']);
  await createNGCCartField(NGCHTMLSCRIPT);
  if (document.getElementById('cart-errors') || document.getElementById('CartDrawer-CartErrors')) {
    let newStyle = document.createElement('style');
    newStyle.type = 'text/css';
    newStyle.innerText = "#cart-errors {display: none;} #CartDrawer-CartErrors{display: none;}";
    document.getElementsByTagName('HEAD').item(0).appendChild(newStyle);
  }
  MutationObserver = window.MutationObserver || window.WebKitMutationObserver;
  let observer = new MutationObserver(async function (mutations, observer) {
    let nid = document.getElementById('_NGC_CART_DRAWER');
    let cart_obj = await _n_getCart();
    let NGCHTMLSCRIPT = await createNGCCartHTMLScrip(cart_obj['items']);
    if((_NCC_Shopify_Theme_Name.includes('Avante') || _NCC_Shopify_Theme_Store_id == '1667')){
     let cartForm = document.querySelector('#cart');
     if(cartForm && cartForm.querySelectorAll('.ngc-note-attr-field').length == 0){
       createNGCCartField(NGCHTMLSCRIPT);
     }
    }
    if (!nid){
      createNGCCartDrawerField(NGCHTMLSCRIPT);
    } 
    
  });
  observer.observe(document, {
    childList: true,
    subtree: true
  });
  let NGCIsShippingDate = true;
  appendNGCCSSToField();
  if (NGCIsShippingDate == true) {
    appendNGCCalendarToField();
    NGCShowCalendarProcess(__n_td);

    if(_NCC_Shopify_Theme_Schema_Name.includes('Expanse') || _NCC_Shopify_Theme_Schema_Name.includes('Motion')){
      document.querySelector('#ngc_haisou_modal')?.addEventListener('click', (e) => {
        e.stopPropagation();
      });
    }
  }
  ngcCartInit(cart_obj['attributes']);
};

function updateNGCCartAttributes(t) {
  const formatAndSetOpenLogiDate = (date) => {
    if (date != '希望なし' && date != '' && date != null) {
      date = date.replace(/\([^\)]*\)/g, "");
      date = date.replace(/\//g,'-');
      document.getElementById('shippingDateResetMsg').style.display ='none';
    } else {
      date = "";
    }
    let n = document.getElementsByName("attributes[open_logi_date]");
    if (n.length == 0) {
      return "";
    }
    for (let a = 0; a < n.length; a++) {
      n[a].value = date;
    }
    return date;
  }
  const formatAndSetOpenLogiTime = (time) => {
    switch (time) {
    case '0812':
      time = '8';
      break;
    case '1416':
      time = '14';
      break;
    case '1618':
      time = '16';
      break;
    case '1820':
      time = '18';
      break;
    case '1921':
      time = '19';
      break;
    default:
      time = '';
      break;
    }
    let n = document.getElementsByName("attributes[open_logi_time]");
    if (n.length == 0) {
      return "";
    }
    for (let a = 0; a < n.length; a++) {
      n[a].value = time;
    }
    return time;
  }
  const formatAndSetNextEngineDate = (date) => {
    if (date != '希望なし' && date != '' && date != null) {
      date = date.replace(/\([^\)]*\)/g, "");
    } else {
      date = "";
    }
    let n = document.getElementsByName("attributes[delivery_date]");
    if (n.length == 0) {
      return "";
    }
    for (let a = 0; a < n.length; a++) {
      n[a].value = date;
    }
    return date;
  }
  const formatAndSetNextEngineime = (time) => {
    switch (time) {
      case '0812':
        time = '08時-12時';
        break;
      case '1214':
        time = '12時-14時';
        break;
      case '1416':
        time = '14時-16時';
        break;
      case '1618':
        time = '16時-18時';
        break;
      case '1820':
        time = '18時-20時';
        break;
      case '1821':
        time = '18時-21時';
        break;
      case '1921':
        time = '19時-21時';
        break;
      case '2021':
        time = '20時-21時';
        break;
      default:
        break;
    }
    let n = document.getElementsByName("attributes[delivery_time]");
    if (n.length == 0) {
      return "";
    }
    for (let a = 0; a < n.length; a++) {
      n[a].value = time;
    }
    return time;
  }
  const formatAndSetNextEngineBikou = (bikou)=> {
    let n = document.getElementsByName("attributes[bikou]");
    if (n.length == 0) {
      return "";
    }
    for (let a = 0; a < n.length; a++) {
      n[a].value = bikou;
    }
    return bikou;
  }
  const formatAndSetNextEngineNumberOnetoFive = (numberOnetoFive) => {
    let n = document.getElementsByName("attributes[12345]");
    if (n.length == 0) {
      return "";
    }
    for (let a = 0; a < n.length; a++) {
      n[a].value = numberOnetoFive;
    }
    return numberOnetoFive;
  }
  let attributes = {};
  let v = t.value;
  let n = t.name;
  n = n.replace("attributes[", "");
  n = n.slice(0, -1);
  if (n == "配送希望日") {
    let de = document.querySelectorAll('._NGC_CFA_shippingdate_select');
    let dv = v;
    for (let a = 0; a < de.length; a++) {
      de[a].value = v;
    }
    attributes['open_logi_date'] = formatAndSetOpenLogiDate(dv);
    attributes['delivery_date'] = formatAndSetNextEngineDate(dv);
  }
  if (n == "配送希望時間") {
    let te = document.querySelectorAll('._NGC_CFA_shippingtime_select');
    let tv = v;
    for (let a = 0; a < te.length; a++) {
      te[a].value = v;
    }
    attributes['open_logi_time'] = formatAndSetOpenLogiTime(tv);
    attributes['delivery_time'] = formatAndSetNextEngineime(tv);
  }
  if (n == "bikou") {
    let te = document.querySelectorAll('._NGC_CFA_note_1');
    let tv = v;
    for (let a = 0; a < te.length; a++) {
      te[a].value = v;
    }
    attributes['bikou'] = formatAndSetNextEngineBikou(tv);
  }
  if (n == "12345") {
    let te = document.querySelectorAll('._NGC_CFA_note_0');
    let tv = v;
    for (let a = 0; a < te.length; a++) {
      te[a].value = v;
    }
    attributes['12345'] = formatAndSetNextEngineNumberOnetoFive(tv);
  }
  attributes[n] = v;
  if (t.type == 'checkbox') {
    let ar = [];
    if (t.checked == true) {
      ar.push(v);
    }
    let isP = true;
    let pe = t.previousElementSibling;
    if (pe) {
      if (pe.name == t.name && pe.type == 'checkbox') {
        if (pe.checked == true && ar.indexOf(pe.value) == -1) {
          ar.push(pe.value);
        }
      } else {
        isP == false;
      }
    } else {
      isP == false;
    }
    while (isP == true && pe) {
      pe = pe.previousElementSibling;
      if (pe) {
        if (pe.name == t.name && pe.type == 'checkbox') {
          if (pe.checked == true && ar.indexOf(pe.value) == -1) {
            ar.push(pe.value);
          }
        } else {
          isP == false;
        }
      } else {
        isP == false;
      }
    }
    let isN = true;
    let ne = t.nextElementSibling;
    if (ne) {
      if (ne.name == t.name && ne.type == 'checkbox') {
        if (ne.checked == true && ar.indexOf(ne.value) == -1) {
          ar.push(ne.value);
        }
      } else {
        isN == false;
      }
    } else {
      isN == false;
    }
    while (isN == true && ne) {
      ne = ne.nextElementSibling;
      if (ne) {
        if (ne.name == t.name && ne.type == 'checkbox') {
          if (ne.checked == true && ar.indexOf(ne.value) == -1) {
            ar.push(ne.value);
          }
        } else {
          isN == false;
        }
      } else {
        isN == false;
      }
    }
    attributes[n] = ar.join(',');
    let nss = document.getElementsByName("attributes[" + n + "]");
    let nar = [];
    let aar = [];
    for (let a = 0; a < nss.length; a++) {
      if (nss[a]['type'] == 'checkbox' && aar.indexOf(nss[a].value) == -1) {
        aar.push(nss[a].value);
      }
    }
    for (let a = 0; a < aar.length; a++) {
      if (ar.indexOf(aar[a]) != -1) {
        nar.push(aar[a]);
      }
    }
    for (let a = 0; a < nss.length; a++) {
      if (nss[a]['type'] == 'hidden') {
        nss[a].value = nar.join(',');
      }
    }
  }
  _NGC_CFA_Ajax_Fetch.post('https://' + _NCC_Shopify_HOST + '/cart/update.js', {attributes: attributes});
}
function checkDateAviliableBeforeClickingCheckOut(e){
  __n_td = new Date();
  NGCShowCalendarProcess(__n_td);
  let click_date_ymd = new Date().toLocaleDateString();
  if(document.querySelector('._NGC_CFA_shippingdate_select')){
    let fv = document.querySelector('._NGC_CFA_shippingdate_select').value.substring(0,10);
    if (!isNaN((new Date(fv)).getTime())) {
      if(_unable_date.indexOf(fv) >= 0 || (new Date(fv)).getTime() < (new Date(click_date_ymd)).getTime()){
        e.preventDefault();
        NGCResetDateValue();
        document.getElementById('shippingDateResetMsg').style.display ='inline';
        return false;
      }
    }
  }
  return true;
}

async function addUpdateNGCCartAttributesToCheckOut(){
    const formatAndSetOpenLogiDate = (date) => {
      if (date != '希望なし' && date != '' && date != null) {
        date = date.replace(/\([^\)]*\)/g, "");
        date = date.replace(/\//g,'-');
        document.getElementById('shippingDateResetMsg').style.display ='none';
      } else {
        date = "";
      }
      let n = document.getElementsByName("attributes[open_logi_date]");
      if (n.length == 0) {
        return "";
      }
      for (let a = 0; a < n.length; a++) {
        n[a].value = date;
      }
      return date;
    }
    const formatAndSetOpenLogiTime = (time) => {
      switch (time) {
      case '0812':
        time = '8';
        break;
      case '1416':
        time = '14';
        break;
      case '1618':
        time = '16';
        break;
      case '1820':
        time = '18';
        break;
      case '1921':
        time = '19';
        break;
      default:
        time = '';
        break;
      }
      let n = document.getElementsByName("attributes[open_logi_time]");
      if (n.length == 0) {
        return "";
      }
      for (let a = 0; a < n.length; a++) {
        n[a].value = time;
      }
      return time;
    }
    const formatAndSetNextEngineDate = (date) => {
      if (date != '希望なし' && date != '' && date != null) {
        date = date.replace(/\([^\)]*\)/g, "");
      } else {
        date = "";
      }
      let n = document.getElementsByName("attributes[delivery_date]");
      if (n.length == 0) {
        return "";
      }
      for (let a = 0; a < n.length; a++) {
        n[a].value = date;
      }
      return date;
    }
    const formatAndSetNextEngineime = (time) => {
      switch (time) {
        case '0812':
          time = '08時-12時';
          break;
        case '1214':
          time = '12時-14時';
          break;
        case '1416':
          time = '14時-16時';
          break;
        case '1618':
          time = '16時-18時';
          break;
        case '1820':
          time = '18時-20時';
          break;
        case '1821':
          time = '18時-21時';
          break;
        case '1921':
          time = '19時-21時';
          break;
        case '2021':
          time = '20時-21時';
          break;
        default:
          break;
      }
      let n = document.getElementsByName("attributes[delivery_time]");
      if (n.length == 0) {
        return "";
      }
      for (let a = 0; a < n.length; a++) {
        n[a].value = time;
      }
      return time;
    }
    let attributes = {};
    if(document.querySelector('._NGC_CFA_shippingdate_select')){
      let de = document.querySelectorAll('._NGC_CFA_shippingdate_select');
      let dv = document.querySelector('._NGC_CFA_shippingdate_select').value;
      for (let a = 0; a < de.length; a++) {
        de[a].value = dv;
      }
      attributes['open_logi_date'] = formatAndSetOpenLogiDate(dv);
      attributes['delivery_date'] = formatAndSetNextEngineDate(dv);
      attributes["配送希望日"] = dv;
    }
    if(document.querySelector('._NGC_CFA_shippingtime_select')){
      let te = document.querySelectorAll('._NGC_CFA_shippingtime_select');
      let tv = document.querySelector('._NGC_CFA_shippingtime_select').value;
      for (let a = 0; a < te.length; a++) {
        te[a].value = tv;
      }
      attributes['open_logi_time'] = formatAndSetOpenLogiTime(tv);
      attributes['delivery_time'] = formatAndSetNextEngineime(tv);
      attributes["配送希望時間"] = tv;
    }
    if(document.querySelector('.ngc_haisou_area')){
      attributes["配送先エリア"] = document.querySelector('.ngc_haisou_area').value;
    }
    return await _NGC_CFA_Ajax_Fetch.post('https://' + _NCC_Shopify_HOST + '/cart/update.js', {attributes: attributes});
}

let ngcNoteAppPathName = location.pathname;

var XtraCheckoutId = document.getElementsByClassName('overlay-tertiary')[1];
var NorthCheckoutId = document.getElementsByClassName('checkout-button')[0];
var NorthSideBar = document.getElementsByClassName('checkout')[0];
var ImpulseCheckoutId = ngcNoteAppPathName.startsWith("/cart") 
    ? (document.querySelector('.cart__item-row.cart__checkout-wrapper')?.querySelector('button[name="checkout"].btn.cart__checkout') || null) 
    : document.getElementsByClassName('cart__checkout')[0];
var PipeLineCheckoutId = document.getElementsByClassName('checkout__button')[0];
var SparkCheckoutId = document.getElementsByClassName('quick-cart__buy-now')[0];
var SparkCartPageCheckoutId = document.getElementsByClassName('btn btn--primary btn--small btn--medium-ns')[0];
var FocalCheckoutId = document.getElementsByClassName('checkout-button button button--primary button--full')[0];
var MotionSideBarCheckoutId = document.getElementsByClassName('btn cart__checkout')[0];
var MotionCartPageCheckoutId = document.getElementsByClassName('btn cart__checkout')[1];
var LorenzaCheckoutId = document.getElementsByClassName('bttn bttn--primary')[0];
var BroadcastCheckoutId = document.getElementsByClassName('btn btn--primary btn--solid btn--full cart__checkout')[0];
var EmpireCheckoutId = document.getElementsByClassName('button-primary mdc-ripple-surface mdc-ripple-upgraded')[2];
var FlowCheckoutId = document.getElementsByClassName('btn cart--button-checkout')[0];
var CombineCheckoutId = document.getElementsByClassName('button button--regular button--solid button--move')[0];
var BaremineralsCheckoutId = document.querySelector('.main-cart__checkout-button');
var BaremineralsCheckoutId2 = document.querySelector('.fluid.button.js-checkout-button:not(.main-cart__checkout-button)');
var TonttuApuCheckoutId = document.getElementsByClassName('p-cart__btn')[0];
var AestheticCheckoutId = document.querySelector('button.cart__checkout-button[name="checkout"]');
var VisionCheckoutId = document.querySelector('button.checkout-button.button.full.accent[name="checkout"][form="cart-form"]');
var VisionDrawerCheckoutId = document.querySelector('button.button.accent.checkout.checkout-button.full[name="checkout"][title="Checkout"]');
var StilettoCheckoutId = document.querySelector("button[name='checkout'].cart__submit.btn.btn--full.btn--primary");
var StilettoDrawerCheckoutId = document.querySelector("button[name='checkout'].quick-cart__submit.btn.btn--full.btn--primary");
var BeYoursCheckoutId = document.querySelector('button.button[name="checkout"][type="submit"]');
var DebutCheckoutId =  document.querySelector('input[name="checkout"][type="submit"].cart__submit');
var HabitatCheckoutId = document.querySelectorAll('button[name="checkout"][type="submit"]')[0];
var HabitatDrawerCheckoutId = document.querySelectorAll('button[name="checkout"][type="submit"]')[1];
var ParallaxDrawerCheckoutId = document.querySelector('input[type="submit"][value="Checkout"]');
var PrestigeCheckoutId; 
PrestigeCheckoutId = document.querySelector(".cart-recap") ? document.querySelector(".cart-recap").lastElementChild : PrestigeCheckoutId;
var PrestigeCheckoutIdOujiShop;
PrestigeCheckoutIdOujiShop = document.querySelector(".cart-recap") ? document.querySelector(".cart-recap").querySelector('button[type="submit"]') : PrestigeCheckoutIdOujiShop;
var PrestigeCheckoutIdNormal = document.querySelector('button[type="submit"][name="checkout"]');
var ExpanseCheckoutId = document.querySelector('button[type="submit"].btn.cart__checkout');
var ExpressionCheckoutId = document.querySelector('button[type="submit"].btn.btn--primary.cart-checkout-button[name="checkout"]');
var BlumCheckoutId = document.querySelector('[type="submit"][name="checkout"][form="cartForm"]');
var BlumDrawerCheckoutId = document.querySelector('[type="submit"][name="checkout"][form="cart-drawer-form"]');

if(document.getElementsByClassName("cart-checkout-btn")[0]){
  var GalleriaCheckoutId = document.getElementsByClassName("cart-checkout-btn")[0];
  GalleriaCheckoutId.setAttribute('id','checkout');
}

if(_NCC_Shopify_Theme_Name.includes('Xtra')){
  XtraCheckoutId.setAttribute('id','checkout');
}  
if(_NCC_Shopify_Theme_Name.includes('North') && NorthCheckoutId){
  NorthCheckoutId.setAttribute('id','checkout');
} 
if(_NCC_Shopify_Theme_Name.includes('North') && NorthSideBar){
  NorthSideBar.setAttribute('id','checkout');
}  
if(_NCC_Shopify_Theme_Name.includes('Motion')){
  MotionSideBarCheckoutId.setAttribute('id','checkout');
}  
if(_NCC_Shopify_Theme_Name.includes('Motion') && MotionCartPageCheckoutId){
  MotionCartPageCheckoutId.setAttribute('id','checkout');
}
if(_NCC_Shopify_Theme_Schema_Name.includes('Impulse')){
  ImpulseCheckoutId.setAttribute('id','checkout');
}
if(_NCC_Shopify_Theme_Name.includes('Pipeline')){
  PipeLineCheckoutId.setAttribute('id','checkout');
}
if(_NCC_Shopify_Theme_Name.includes('Spark') || _NCC_Shopify_Theme_Store_id == '911'){
  SparkCheckoutId.setAttribute('id','checkout');
}
if(_NCC_Shopify_Theme_Name.includes('Spark') && SparkCartPageCheckoutId){
  SparkCartPageCheckoutId.setAttribute('id','checkout');
}
if(_NCC_Shopify_Theme_Name.includes('Lorenza')){
  LorenzaCheckoutId.setAttribute('id','checkout');
}
if(_NCC_Shopify_Theme_Name.includes('Broadcast')){
  BroadcastCheckoutId.setAttribute('id','checkout');
  let n = document.createElement('style');
  n.type = 'text/css';
  n.innerText = '.ngc_haisou_td{display: table-cell !important}';
  document.getElementsByTagName('HEAD').item(0).appendChild(n);
}
if(_NCC_Shopify_Theme_Name.includes('Empire')){
  EmpireCheckoutId.setAttribute('id','checkout');
}
if(_NCC_Shopify_Theme_Name.includes('Flow') && FlowCheckoutId){
  FlowCheckoutId.setAttribute('id','checkout');
}
if(_NCC_Shopify_Theme_Name.includes('Combine') && CombineCheckoutId){
  CombineCheckoutId.setAttribute('id','checkout');
}
if((_NCC_Shopify_Theme_Schema_Name == 'Prestige' || _NCC_Shopify_Theme_Store_id == '855') && PrestigeCheckoutId){
  PrestigeCheckoutId.setAttribute('id','checkout');
  document.querySelector('#checkout').disabled = true;
}
if((_NCC_Shopify_Theme_Schema_Name == 'Prestige' || _NCC_Shopify_Theme_Store_id == '855') &&  PrestigeCheckoutIdOujiShop && !PrestigeCheckoutId){
  PrestigeCheckoutIdOujiShop.setAttribute('id','checkout');
  document.querySelector('#checkout').disabled = true;
}
if((_NCC_Shopify_Theme_Schema_Name == 'Prestige' || _NCC_Shopify_Theme_Store_id == '855') && PrestigeCheckoutIdNormal && !PrestigeCheckoutId && !PrestigeCheckoutIdOujiShop){
  PrestigeCheckoutIdNormal.setAttribute('id','checkout');
}
if((_NCC_Shopify_Theme_Name.includes('Bare-minerals') || _NCC_Shopify_Theme_id == '157645832478') && BaremineralsCheckoutId){
  BaremineralsCheckoutId.setAttribute('id','checkout');
}
if(_NCC_Shopify_Theme_Name.includes('サンタクロース村 トントゥアプ') && TonttuApuCheckoutId){
  TonttuApuCheckoutId.setAttribute('id','checkout');
}
if(_NCC_Shopify_Theme_Store_id == '2514' && AestheticCheckoutId){
  AestheticCheckoutId.setAttribute('id','checkout');
}
if((_NCC_Shopify_Theme_Name.includes('Vision') || _NCC_Shopify_Theme_Store_id == '2053') && VisionCheckoutId){
  VisionCheckoutId.setAttribute('id','checkout');
}
if((_NCC_Shopify_Theme_Name.includes('Vision') || _NCC_Shopify_Theme_Store_id == '2053') && VisionDrawerCheckoutId){
  VisionDrawerCheckoutId.setAttribute('id','CartDrawer-Checkout');
}
if((_NCC_Shopify_Theme_Name.includes('Stiletto') || _NCC_Shopify_Theme_Store_id == '1621') && StilettoCheckoutId){
  StilettoCheckoutId.setAttribute('id','checkout');
}
if((_NCC_Shopify_Theme_Name.includes('Stiletto') || _NCC_Shopify_Theme_Store_id == '1621') && StilettoDrawerCheckoutId){
  StilettoDrawerCheckoutId.setAttribute('id','CartDrawer-Checkout');
}
if((_NCC_Shopify_Theme_Name.includes('Be Yours') ||_NCC_Shopify_Theme_Store_id == '1399') && BeYoursCheckoutId){
  BeYoursCheckoutId.setAttribute('id','checkout');
}
if((_NCC_Shopify_Theme_Name.includes('Debut') ||_NCC_Shopify_Theme_Store_id == '796') && DebutCheckoutId){
  DebutCheckoutId.setAttribute('id','checkout');
}
if((_NCC_Shopify_Theme_Name.includes('Habitat') ||_NCC_Shopify_Theme_Store_id == '1581')  && HabitatCheckoutId){
  HabitatCheckoutId.setAttribute('id','checkout');
}
if((_NCC_Shopify_Theme_Name.includes('Habitat') ||_NCC_Shopify_Theme_Store_id == '1581')  && HabitatDrawerCheckoutId){
  HabitatDrawerCheckoutId.setAttribute('id','CartDrawer-Checkout');
}
if(_NCC_Shopify_Theme_Schema_Name == "Parallax" && ParallaxDrawerCheckoutId){
  ParallaxDrawerCheckoutId.setAttribute('id','CartDrawer-Checkout');
}
if(_NCC_Shopify_Theme_Schema_Name == "Expanse" && ExpanseCheckoutId){
  ExpanseCheckoutId.setAttribute('id','checkout');
}
if(_NCC_Shopify_Theme_Schema_Name == "Expression" && ExpressionCheckoutId){
  ExpressionCheckoutId.setAttribute('id','checkout');
}
if(_NCC_Shopify_Theme_Schema_Name == "Blum"  && BlumCheckoutId){
  BlumCheckoutId.setAttribute('id','checkout');
}
if(_NCC_Shopify_Theme_Schema_Name == "Blum"  && BlumDrawerCheckoutId){
  BlumDrawerCheckoutId.setAttribute('id','CartDrawer-Checkout');
}

if(document.getElementById('checkout')){
  document.getElementById('checkout').addEventListener('click',function(e){ 
    let fileds = document.getElementsByClassName('_NGC_CFA_note_field');
    let goNextPage = true;
    for (let a = 0; a < fileds.length; a++) {
      const item = fileds[a];
      if (document.getElementById('checknull_'+item.id)) {
        let filedsTag = item.tagName;
        let filedsType = item.type;
        let filedsValue = item.value;
        let filedsName = item.name;
        let isNullOrNot = document.getElementById('checknull_'+item.id).value;
        let errMessage = document.getElementById('errMessage_'+item.id).value;
        if ((filedsTag == "INPUT" && filedsType == "text") || filedsTag == "TEXTAREA" || filedsTag == "SELECT") {
          if((filedsValue == '' || filedsValue == '選択なし') && isNullOrNot == 'must' && errMessage !=''){
            e.preventDefault();
            document.getElementById('displayerrMessage_'+item.id).innerHTML= errMessage;
            goNextPage = false;
          } else if(isNullOrNot != 'must' && filedsValue == ''){
              if(document.getElementById(item.id)){
                document.getElementById(item.id).value = ' ';
              }            
          } else{
            document.getElementById('displayerrMessage_'+item.id).innerHTML='';
          }
        }
        if ((filedsTag == "INPUT" && filedsType == "radio") || (filedsTag == "INPUT" && filedsType == "checkbox")) {
          let els = Array.from(document.getElementsByName(filedsName));
          let rs = els.filter(el => el.checked == true);
          if(isNullOrNot == 'must' && errMessage !='' && rs.length == 0){
            e.preventDefault();      
            document.getElementById('displayerrMessage_'+item.id).innerHTML= errMessage;
            goNextPage = false;
          }else{
            document.getElementById('displayerrMessage_'+item.id).innerHTML='';
          }
        }
      }
    }
    if(checkDateAviliableBeforeClickingCheckOut(e) && goNextPage){
      addUpdateNGCCartAttributesToCheckOut().then(() => {
        window.location.href = '/checkout'; 
      });
    }
  })
}
if(document.getElementById('CartDrawer-Checkout')){
  document.getElementById('CartDrawer-Checkout').addEventListener('click',function(e){ 
    let fileds = document.getElementsByClassName('_NGC_CFA_note_field');
    let goNextPage = true;
    for (let a = 0; a < fileds.length; a++) {
      const item = fileds[a];
      if (document.getElementById('checknull_'+item.id)) {
        let filedsTag = item.tagName;
        let filedsType = item.type;
        let filedsValue = item.value;
        let filedsName = item.name;
        let isNullOrNot = document.getElementById('checknull_'+item.id).value;
        let errMessage = document.getElementById('errMessage_'+item.id).value;
        if ((filedsTag == "INPUT" && filedsType == "text") || filedsTag == "TEXTAREA" || filedsTag == "SELECT") {
          if((filedsValue == '' || filedsValue == '選択なし') && isNullOrNot == 'must' && errMessage !=''){
            e.preventDefault();
            document.getElementById('displayerrMessage_'+item.id).innerHTML= errMessage;
            goNextPage = false;
            } else if(isNullOrNot != 'must' && filedsValue == ''){
              if(document.getElementById(item.id)){
                document.getElementById(item.id).value = ' ';
              }            
          } else{
            document.getElementById('displayerrMessage_'+item.id).innerHTML='';
          }
        }
        if ((filedsTag == "INPUT" && filedsType == "radio") || (filedsTag == "INPUT" && filedsType == "checkbox")) {
          let els = Array.from(document.getElementsByName(filedsName));
          let rs = els.filter(el => el.checked == true);
          if(isNullOrNot == 'must' && errMessage !='' && rs.length == 0){
            e.preventDefault();      
            document.getElementById('displayerrMessage_'+item.id).innerHTML= errMessage;
            goNextPage = false;
          }else{
            document.getElementById('displayerrMessage_'+item.id).innerHTML='';
          }
        }
      }
    }
    if(checkDateAviliableBeforeClickingCheckOut(e) && goNextPage){
      addUpdateNGCCartAttributesToCheckOut().then(() => {
        window.location.href = '/checkout'; 
      });
    }
  })
}
if(_NCC_Shopify_Theme_Name.includes('Dawn') && document.getElementById('CartDrawer-CartItems')){
  let mutationObserver = new MutationObserver(mutations => {
    document.getElementById('CartDrawer-Checkout').addEventListener('click',function(e){
      let fileds = document.getElementsByClassName('_NGC_CFA_note_field');
      for (let a = 0; a < fileds.length; a++) {
        const item = fileds[a];
        if (document.getElementById('checknull_'+item.id)) {
          let filedsTag = item.tagName;
          let filedsType = item.type;
          let filedsValue = item.value;
          let filedsName = item.name;
          let isNullOrNot = document.getElementById('checknull_'+item.id).value;
          let errMessage = document.getElementById('errMessage_'+item.id).value;
          if ((filedsTag == "INPUT" && filedsType == "text") || filedsTag == "TEXTAREA" || filedsTag == "SELECT") {
            if((filedsValue == '' || filedsValue == '選択なし') && isNullOrNot == 'must' && errMessage !=''){
              e.preventDefault();
              document.getElementById('displayerrMessage_'+item.id).innerHTML= errMessage;
            } else if(isNullOrNot != 'must' && filedsValue == ''){
                if(document.getElementById(item.id)){
                  document.getElementById(item.id).value = ' ';
                }            
            } else{
              document.getElementById('displayerrMessage_'+item.id).innerHTML='';
            }
          }
          if ((filedsTag == "INPUT" && filedsType == "radio") || (filedsTag == "INPUT" && filedsType == "checkbox")) {
            let els = Array.from(document.getElementsByName(filedsName));
            let rs = els.filter(el => el.checked == true);
            if(isNullOrNot == 'must' && errMessage !='' && rs.length == 0){
              e.preventDefault();      
              document.getElementById('displayerrMessage_'+item.id).innerHTML= errMessage;
            }else{
              document.getElementById('displayerrMessage_'+item.id).innerHTML='';
            }
          }
        }
      }
      checkDateAviliableBeforeClickingCheckOut(e);
      addUpdateNGCCartAttributesToCheckOut();
    })  
  })
  const element = document.getElementsByClassName("drawer")[0];
  const options = {
	attributes: true, 
	attributeFilter: ["class"]
    }
  mutationObserver.observe(element, options)
}
if((_NCC_Shopify_Theme_Name.includes('Origin') || _NCC_Shopify_Theme_Store_id == '1841') && document.getElementById('CartDrawer-CartItems')){
  let mutationObserver = new MutationObserver(mutations => {
    document.getElementById('CartDrawer-Checkout').addEventListener('click',function(e){
      let fileds = document.getElementsByClassName('_NGC_CFA_note_field');
      for (let a = 0; a < fileds.length; a++) {
        const item = fileds[a];
        if (document.getElementById('checknull_'+item.id)) {
          let filedsTag = item.tagName;
          let filedsType = item.type;
          let filedsValue = item.value;
          let filedsName = item.name;
          let isNullOrNot = document.getElementById('checknull_'+item.id).value;
          let errMessage = document.getElementById('errMessage_'+item.id).value;
          if ((filedsTag == "INPUT" && filedsType == "text") || filedsTag == "TEXTAREA" || filedsTag == "SELECT") {
            if((filedsValue == '' || filedsValue == '選択なし') && isNullOrNot == 'must' && errMessage !=''){
              e.preventDefault();
              document.getElementById('displayerrMessage_'+item.id).innerHTML= errMessage;
            } else if(isNullOrNot != 'must' && filedsValue == ''){
                if(document.getElementById(item.id)){
                  document.getElementById(item.id).value = ' ';
                }            
            } else{
              document.getElementById('displayerrMessage_'+item.id).innerHTML='';
            }
          }
          if ((filedsTag == "INPUT" && filedsType == "radio") || (filedsTag == "INPUT" && filedsType == "checkbox")) {
            let els = Array.from(document.getElementsByName(filedsName));
            let rs = els.filter(el => el.checked == true);
            if(isNullOrNot == 'must' && errMessage !='' && rs.length == 0){
              e.preventDefault();      
              document.getElementById('displayerrMessage_'+item.id).innerHTML= errMessage;
            }else{
              document.getElementById('displayerrMessage_'+item.id).innerHTML='';
            }
          }
        }
      }
      checkDateAviliableBeforeClickingCheckOut(e);
    })  
  })
  const element = document.getElementsByClassName("drawer")[0];
  const options = {
	attributes: true, 
	attributeFilter: ["class"]
    }
  mutationObserver.observe(element, options)
}
if((_NCC_Shopify_Theme_Name.includes('Be Yours') ||_NCC_Shopify_Theme_Store_id == '1399') && document.getElementsByClassName("cart-drawer-container")[0]){
  let mutationObserver = new MutationObserver(mutations => {
    document.getElementsByClassName("button-container")[0].childNodes.item(1).setAttribute('id','checkout')
    document.getElementById('checkout').addEventListener('click',function(e){
      let fileds = document.getElementsByClassName('_NGC_CFA_note_field');
      for (let a = 0; a < fileds.length; a++) {
        const item = fileds[a];
        if (document.getElementById('checknull_'+item.id)) {
          let filedsTag = item.tagName;
          let filedsType = item.type;
          let filedsValue = item.value;
          let filedsName = item.name;
          let isNullOrNot = document.getElementById('checknull_'+item.id).value;
          let errMessage = document.getElementById('errMessage_'+item.id).value;
          if ((filedsTag == "INPUT" && filedsType == "text") || filedsTag == "TEXTAREA" || filedsTag == "SELECT") {
            if((filedsValue == '' || filedsValue == '選択なし') && isNullOrNot == 'must' && errMessage !=''){
              e.preventDefault();
              document.getElementById('displayerrMessage_'+item.id).innerHTML= errMessage;
            } else if(isNullOrNot != 'must' && filedsValue == ''){
                if(document.getElementById(item.id)){
                  document.getElementById(item.id).value = ' ';
                }            
            } else{
              document.getElementById('displayerrMessage_'+item.id).innerHTML='';
            }
          }
          if ((filedsTag == "INPUT" && filedsType == "radio") || (filedsTag == "INPUT" && filedsType == "checkbox")) {
            let els = Array.from(document.getElementsByName(filedsName));
            let rs = els.filter(el => el.checked == true);
            if(isNullOrNot == 'must' && errMessage !='' && rs.length == 0){
              e.preventDefault();      
              document.getElementById('displayerrMessage_'+item.id).innerHTML= errMessage;
            }else{
              document.getElementById('displayerrMessage_'+item.id).innerHTML='';
            }
          }
        }
      }
      checkDateAviliableBeforeClickingCheckOut(e);
      addUpdateNGCCartAttributesToCheckOut();
    })  
    let ngc_haisou_modal = document.querySelector('#ngc_haisou_modal');
    if(ngc_haisou_modal){
      ngc_haisou_modal.addEventListener('click', (event) => {
          event.stopPropagation();
      })
    }
  })
  const element = document.getElementsByClassName("cart-drawer focus-inset")[0];
  const options = {
    childList: true
    }
  mutationObserver.observe(element, options)
}
if(_NCC_Shopify_Theme_Name.includes('Spark') && location.pathname.startsWith("/cart")){
  document.getElementsByClassName("btn--medium-ns")[1].addEventListener('click',function(e){ 
    let fileds = document.getElementsByClassName('_NGC_CFA_note_field');
    for (let a = 0; a < fileds.length; a++) {
      const item = fileds[a];
      if (document.getElementById('checknull_'+item.id)) {
        let filedsTag = item.tagName;
        let filedsType = item.type;
        let filedsValue = item.value;
        let filedsName = item.name;
        let isNullOrNot = document.getElementById('checknull_'+item.id).value;
        let errMessage = document.getElementById('errMessage_'+item.id).value;
        if ((filedsTag == "INPUT" && filedsType == "text") || filedsTag == "TEXTAREA" || filedsTag == "SELECT") {
          if((filedsValue == '' || filedsValue == '選択なし') && isNullOrNot == 'must' && errMessage !=''){
            e.preventDefault();
            document.getElementsByClassName('errMessageClass_'+item.id)[0].innerHTML= errMessage;
          }else{
            document.getElementsByClassName('errMessageClass_'+item.id)[0].innerHTML='';
          }
        }
        if ((filedsTag == "INPUT" && filedsType == "radio") || (filedsTag == "INPUT" && filedsType == "checkbox")) {
          let els = Array.from(document.getElementsByName(filedsName));
          let rs = els.filter(el => el.checked == true);
          if(isNullOrNot == 'must' && errMessage !='' && rs.length == 0){
            e.preventDefault();      
			      document.getElementsByClassName('errMessageClass_'+item.id)[0].innerHTML= errMessage;
          }else{
            document.getElementsByClassName('errMessageClass_'+item.id)[0].innerHTML='';
          }
        }
      }
    }
    checkDateAviliableBeforeClickingCheckOut(e);
  })
}
if((_NCC_Shopify_Theme_Name.includes('Focal') || _NCC_Shopify_Theme_Store_id == '714')&& !location.pathname.startsWith("/cart")){
  const element = document.querySelector("cart-drawer")
  if(element){
    const observer = new MutationObserver(() => {
      const checkoutBtn = document.getElementsByClassName('checkout-button button button--primary button--full')[0];
      if (checkoutBtn && !checkoutBtn.dataset.ngcBound) {
        checkoutBtn.dataset.ngcBound = "true";
        checkoutBtn.onclick = function fn(e) {
          let fileds = document.getElementsByClassName('_NGC_CFA_note_field');
          for (let a = 0; a < fileds.length; a++) {
            const item = fileds[a];
            if (document.getElementById('checknull_' + item.id)) {
              let filedsTag = item.tagName;
              let filedsType = item.type;
              let filedsValue = item.value;
              let filedsName = item.name;
              let isNullOrNot = document.getElementById('checknull_' + item.id).value;
              let errMessage = document.getElementById('errMessage_' + item.id).value;
              if ((filedsTag == "INPUT" && filedsType == "text") || filedsTag == "TEXTAREA" || filedsTag == "SELECT") {
                if ((filedsValue == '' || filedsValue == '選択なし') && isNullOrNot == 'must' && errMessage != '') {
                  document.getElementsByClassName('errMessageClass_' + item.id)[0].innerHTML = errMessage;
                  e.preventDefault();
                } else {
                  document.getElementsByClassName('errMessageClass_' + item.id)[0].innerHTML = '';
                }
              }
              if ((filedsTag == "INPUT" && filedsType == "radio") || (filedsTag == "INPUT" && filedsType == "checkbox")) {
                let els = Array.from(document.getElementsByName(filedsName));
                let rs = els.filter(el => el.checked == true);
                if (isNullOrNot == 'must' && errMessage != '' && rs.length == 0) {
                  document.getElementsByClassName('errMessageClass_' + item.id)[0].innerHTML = errMessage;
                  e.preventDefault();
                } else {
                  document.getElementsByClassName('errMessageClass_' + item.id)[0].innerHTML = '';
                }
              }
            }
          }
          checkDateAviliableBeforeClickingCheckOut(e);
        };
      }
    });
  
    observer.observe(element, {
      childList: true,
      subtree: true
    });
  }
}
if((_NCC_Shopify_Theme_Name.includes('Focal') || _NCC_Shopify_Theme_Store_id == '714') && location.pathname.startsWith("/cart")){
   document.getElementsByClassName('checkout-button button button--primary button--full')[0].onclick = function fn(e){
      let fileds = document.getElementsByClassName('_NGC_CFA_note_field');
      for (let a = 0; a < fileds.length; a++) {
        const item = fileds[a];
        if (document.getElementById('checknull_'+item.id)) {
          let filedsTag = item.tagName;
          let filedsType = item.type;
          let filedsValue = item.value;
          let filedsName = item.name;
          let isNullOrNot = document.getElementById('checknull_'+item.id).value;
          let errMessage = document.getElementById('errMessage_'+item.id).value;
          if ((filedsTag == "INPUT" && filedsType == "text") || filedsTag == "TEXTAREA" || filedsTag == "SELECT") {
            if((filedsValue == '' || filedsValue == '選択なし') && isNullOrNot == 'must' && errMessage !=''){
              document.getElementsByClassName('errMessageClass_'+item.id)[0].innerHTML= errMessage;
              e.preventDefault();
            }else{
              document.getElementsByClassName('errMessageClass_'+item.id)[0].innerHTML='';
            }
          }
          if ((filedsTag == "INPUT" && filedsType == "radio") || (filedsTag == "INPUT" && filedsType == "checkbox")) {
            let els = Array.from(document.getElementsByName(filedsName));
            let rs = els.filter(el => el.checked == true);
            if(isNullOrNot == 'must' && errMessage !='' && rs.length == 0){
              document.getElementsByClassName('errMessageClass_'+item.id)[0].innerHTML= errMessage;
              e.preventDefault();
            }else{
              document.getElementsByClassName('errMessageClass_'+item.id)[0].innerHTML='';
            }
          }
        }
      }
      checkDateAviliableBeforeClickingCheckOut(e);
    }  

  if(_NCC_Shopify_HOST ==="f-room.shop"){
    let mutationObserver = new MutationObserver(mutations => {
      if(!document.getElementsByClassName("hover:ag-text-gray-600 active:ag-text-gray-900 ag-flex ag-items-center ag-p-0 ag-m-0 ag-h-auto ag-text-2xl ag-text-gray-700 anygift-button anygift-option-button")[0].childNodes[0].classList.contains("anygift-option-button__circle-active")){
        for(let i = 0; i<= document.getElementsByClassName("ngc-note-attr-field").length; i++){
          if(document.getElementsByClassName("ngc-note-attr-field")[i]){
            document.getElementsByClassName("ngc-note-attr-field")[i].setAttribute("style","display:none")
          }
        }
      }
      else{
        for(let i = 0; i<= document.getElementsByClassName("ngc-note-attr-field").length; i++){
          if(document.getElementsByClassName("ngc-note-attr-field")[i]){
            document.getElementsByClassName("ngc-note-attr-field")[i].removeAttribute("style")
          }
        }
      }
    })
    const element = document.getElementsByClassName("hover:ag-text-gray-600 active:ag-text-gray-900 ag-flex ag-items-center ag-p-0 ag-m-0 ag-h-auto ag-text-2xl ag-text-gray-700 anygift-button anygift-option-button")[0].childNodes[0];
    const options = {
       childList: true
    }
    mutationObserver.observe(element, options)
  }
}
if(_NCC_Shopify_Theme_Name.includes('Empire') && location.pathname.startsWith("/cart")){
  document.getElementsByClassName("button-primary cart-title-button mdc-ripple-surface mdc-ripple-upgraded")[0].addEventListener('click',function(e){ 
    let fileds = document.getElementsByClassName('_NGC_CFA_note_field');
    for (let a = 0; a < fileds.length; a++) {
      const item = fileds[a];
      if (document.getElementById('checknull_'+item.id)) {
        let filedsTag = item.tagName;
        let filedsType = item.type;
        let filedsValue = item.value;
        let filedsName = item.name;
        let isNullOrNot = document.getElementById('checknull_'+item.id).value;
        let errMessage = document.getElementById('errMessage_'+item.id).value;
        if ((filedsTag == "INPUT" && filedsType == "text") || filedsTag == "TEXTAREA" || filedsTag == "SELECT") {
          if((filedsValue == '' || filedsValue == '選択なし') && isNullOrNot == 'must' && errMessage !=''){
            e.preventDefault();
            document.getElementsByClassName('errMessageClass_'+item.id)[0].innerHTML= errMessage;
          }else{
            document.getElementsByClassName('errMessageClass_'+item.id)[0].innerHTML='';
          }
        }
        if ((filedsTag == "INPUT" && filedsType == "radio") || (filedsTag == "INPUT" && filedsType == "checkbox")) {
          let els = Array.from(document.getElementsByName(filedsName));
          let rs = els.filter(el => el.checked == true);
          if(isNullOrNot == 'must' && errMessage !='' && rs.length == 0){
            e.preventDefault();      
			      document.getElementsByClassName('errMessageClass_'+item.id)[0].innerHTML= errMessage;
          }else{
            document.getElementsByClassName('errMessageClass_'+item.id)[0].innerHTML='';
          }
        }
      }
    }
    checkDateAviliableBeforeClickingCheckOut(e);
  })
}
if(_NCC_Shopify_Theme_Name.includes('Flow') && location.pathname.startsWith("/cart")){
  document.getElementsByClassName('btn cart--button-checkout')[0].addEventListener('click',function(e){ 
    let fileds = document.getElementsByClassName('_NGC_CFA_note_field');
    for (let a = 0; a < fileds.length; a++) {
      const item = fileds[a];
      if (document.getElementById('checknull_'+item.id)) {
        let filedsTag = item.tagName;
        let filedsType = item.type;
        let filedsValue = item.value;
        let filedsName = item.name;
        let isNullOrNot = document.getElementById('checknull_'+item.id).value;
        let errMessage = document.getElementById('errMessage_'+item.id).value;
        if ((filedsTag == "INPUT" && filedsType == "text") || filedsTag == "TEXTAREA" || filedsTag == "SELECT") {
          if((filedsValue == '' || filedsValue == '選択なし') && isNullOrNot == 'must' && errMessage !=''){
            e.preventDefault();
            document.getElementsByClassName('errMessageClass_'+item.id)[0].innerHTML= errMessage;
          }else{
            document.getElementsByClassName('errMessageClass_'+item.id)[0].innerHTML='';
          }
        }
        if ((filedsTag == "INPUT" && filedsType == "radio") || (filedsTag == "INPUT" && filedsType == "checkbox")) {
          let els = Array.from(document.getElementsByName(filedsName));
          let rs = els.filter(el => el.checked == true);
          if(isNullOrNot == 'must' && errMessage !='' && rs.length == 0){
            e.preventDefault();      
			      document.getElementsByClassName('errMessageClass_'+item.id)[0].innerHTML= errMessage;
          }else{
            document.getElementsByClassName('errMessageClass_'+item.id)[0].innerHTML='';
          }
        }
      }
    }
    checkDateAviliableBeforeClickingCheckOut(e);
  })
}
if(_NCC_Shopify_Theme_Name.includes('Yuva') && location.pathname.startsWith("/cart")){
  document.getElementById("cartCheckout").addEventListener('click',function(e){ 
    let fileds = document.getElementsByClassName('_NGC_CFA_note_field');
    for (let a = 0; a < fileds.length; a++) {
      const item = fileds[a];
      if (document.getElementById('checknull_'+item.id)) {
        let filedsTag = item.tagName;
        let filedsType = item.type;
        let filedsValue = item.value;
        let filedsName = item.name;
        let isNullOrNot = document.getElementById('checknull_'+item.id).value;
        let errMessage = document.getElementById('errMessage_'+item.id).value;
        if ((filedsTag == "INPUT" && filedsType == "text") || filedsTag == "TEXTAREA" || filedsTag == "SELECT") {
          if((filedsValue == '' || filedsValue == '選択なし') && isNullOrNot == 'must' && errMessage !=''){
            e.preventDefault();
            document.getElementsByClassName('errMessageClass_'+item.id)[0].innerHTML= errMessage;
          }else{
            document.getElementsByClassName('errMessageClass_'+item.id)[0].innerHTML='';
          }
        }
        if ((filedsTag == "INPUT" && filedsType == "radio") || (filedsTag == "INPUT" && filedsType == "checkbox")) {
          let els = Array.from(document.getElementsByName(filedsName));
          let rs = els.filter(el => el.checked == true);
          if(isNullOrNot == 'must' && errMessage !='' && rs.length == 0){
            e.preventDefault();      
			      document.getElementsByClassName('errMessageClass_'+item.id)[0].innerHTML= errMessage;
          }else{
            document.getElementsByClassName('errMessageClass_'+item.id)[0].innerHTML='';
          }
        }
      }
    }
  })
}
if((_NCC_Shopify_Theme_Schema_Name == 'Prestige' || _NCC_Shopify_Theme_Store_id == '855') && !location.pathname.startsWith("/cart")){
  let mutationObserver = new MutationObserver(mutations => {
    if(document.getElementsByClassName("button-group")[0]){
      document.getElementsByClassName("button-group")[0].firstElementChild.setAttribute('id','checkout')
      document.getElementById('checkout').addEventListener('click',function(e){
        let fileds = document.getElementsByClassName('_NGC_CFA_note_field');
        for (let a = 0; a < fileds.length; a++) {
          const item = fileds[a];
          if (document.getElementById('checknull_'+item.id)) {
            let filedsTag = item.tagName;
            let filedsType = item.type;
            let filedsValue = item.value;
            let filedsName = item.name;
            let isNullOrNot = document.getElementById('checknull_'+item.id).value;
            let errMessage = document.getElementById('errMessage_'+item.id).value;
            if ((filedsTag == "INPUT" && filedsType == "text") || filedsTag == "TEXTAREA" || filedsTag == "SELECT") {
              if((filedsValue == '' || filedsValue == '選択なし') && isNullOrNot == 'must' && errMessage !=''){
                e.preventDefault();
                document.getElementById('displayerrMessage_'+item.id).innerHTML= errMessage;
              } else if(isNullOrNot != 'must' && filedsValue == ''){
                  if(document.getElementById(item.id)){
                    document.getElementById(item.id).value = ' ';
                  }            
              } else{
                document.getElementById('displayerrMessage_'+item.id).innerHTML='';
              }
            }
            if ((filedsTag == "INPUT" && filedsType == "radio") || (filedsTag == "INPUT" && filedsType == "checkbox")) {
              let els = Array.from(document.getElementsByName(filedsName));
              let rs = els.filter(el => el.checked == true);
              if(isNullOrNot == 'must' && errMessage !='' && rs.length == 0){
                e.preventDefault();      
                document.getElementById('displayerrMessage_'+item.id).innerHTML= errMessage;
              }else{
                document.getElementById('displayerrMessage_'+item.id).innerHTML='';
              }
            }
          }
        }
        checkDateAviliableBeforeClickingCheckOut(e);
      })  
    }
  })
  const element = document.getElementsByClassName('features--button-transition features--zoom-image')[0];
  const options = {
    childList: true
    }
  mutationObserver.observe(element, options)
}
if(_NCC_Shopify_Theme_Name.includes('Spark') || _NCC_Shopify_HOST ==="iromiso.jp"){
  const targetNode = document.querySelector('.quick-cart');
  const observer = new MutationObserver(async (mutationsList, observer) => {
    for (let mutation of mutationsList) {
      if (mutation.type === 'attributes' && mutation.attributeName === 'class') {
        if(document.querySelector('.quick-cart').classList.contains('visible')){
          let cart_obj = await _n_getCart();
          ngcCartInit(cart_obj['attributes']);
          addUpdateNGCCartAttributesToCheckOut();
        }
      }
    }
  });
  const config = { attributes: true, attributeFilter: ['class'] };
  observer.observe(targetNode, config)
}
if((_NCC_Shopify_Theme_Name.includes('Refresh') || _NCC_Shopify_Theme_Store_id == '1567')&& !location.pathname.startsWith("/cart")){
  const element = document.querySelector("cart-drawer")
  element.addEventListener('DOMSubtreeModified',()=>{
    if(document.getElementById('CartDrawer-Checkout')){
      document.getElementById('CartDrawer-Checkout').addEventListener('click',function(e){ 
        let fileds = document.getElementsByClassName('_NGC_CFA_note_field');
        for (let a = 0; a < fileds.length; a++) {
          const item = fileds[a];
          if (document.getElementById('checknull_'+item.id)) {
            let filedsTag = item.tagName;
            let filedsType = item.type;
            let filedsValue = item.value;
            let filedsName = item.name;
            let isNullOrNot = document.getElementById('checknull_'+item.id).value;
            let errMessage = document.getElementById('errMessage_'+item.id).value;
            if ((filedsTag == "INPUT" && filedsType == "text") || filedsTag == "TEXTAREA" || filedsTag == "SELECT") {
              if((filedsValue == '' || filedsValue == '選択なし') && isNullOrNot == 'must' && errMessage !=''){
                e.preventDefault();
                document.getElementById('displayerrMessage_'+item.id).innerHTML= errMessage;
              } else if(isNullOrNot != 'must' && filedsValue == ''){
                  if(document.getElementById(item.id)){
                    document.getElementById(item.id).value = ' ';
                  }            
              } else{
                document.getElementById('displayerrMessage_'+item.id).innerHTML='';
              }
            }
            if ((filedsTag == "INPUT" && filedsType == "radio") || (filedsTag == "INPUT" && filedsType == "checkbox")) {
              let els = Array.from(document.getElementsByName(filedsName));
              let rs = els.filter(el => el.checked == true);
              if(isNullOrNot == 'must' && errMessage !='' && rs.length == 0){
                e.preventDefault();      
                document.getElementById('displayerrMessage_'+item.id).innerHTML= errMessage;
              }else{
                document.getElementById('displayerrMessage_'+item.id).innerHTML='';
              }
            }
          }
        }
        checkDateAviliableBeforeClickingCheckOut(e);
      })
    }
  })
}
if(_NCC_Shopify_Shop == 'kubota-sangyo.myshopify.com' && document.querySelector('.cart__checkout-button')){
  document.querySelector('.cart__checkout-button').addEventListener('click',function(e){ 
    let fileds = document.getElementsByClassName('_NGC_CFA_note_field');
    for (let a = 0; a < fileds.length; a++) {
      const item = fileds[a];
      if (document.getElementById('checknull_'+item.id)) {
        let filedsTag = item.tagName;
        let filedsType = item.type;
        let filedsValue = item.value;
        let filedsName = item.name;
        let isNullOrNot = document.getElementById('checknull_'+item.id).value;
        let errMessage = document.getElementById('errMessage_'+item.id).value;
        if ((filedsTag == "INPUT" && filedsType == "text") || filedsTag == "TEXTAREA" || filedsTag == "SELECT") {
          if((filedsValue == '' || filedsValue == '選択なし') && isNullOrNot == 'must' && errMessage !=''){
            e.preventDefault();
            document.getElementById('displayerrMessage_'+item.id).innerHTML= errMessage;
          } else if(isNullOrNot != 'must' && filedsValue == ''){
              if(document.getElementById(item.id)){
                document.getElementById(item.id).value = ' ';
              }            
          } else{
            document.getElementById('displayerrMessage_'+item.id).innerHTML='';
          }
        }
        if ((filedsTag == "INPUT" && filedsType == "radio") || (filedsTag == "INPUT" && filedsType == "checkbox")) {
          let els = Array.from(document.getElementsByName(filedsName));
          let rs = els.filter(el => el.checked == true);
          if(isNullOrNot == 'must' && errMessage !='' && rs.length == 0){
            e.preventDefault();      
            document.getElementById('displayerrMessage_'+item.id).innerHTML= errMessage;
          }else{
            document.getElementById('displayerrMessage_'+item.id).innerHTML='';
          }
        }
      }
    }
    checkDateAviliableBeforeClickingCheckOut(e);
  })
}
if((_NCC_Shopify_Theme_Name.includes('Bare-minerals') || _NCC_Shopify_Theme_id == '157645832478') && BaremineralsCheckoutId2){
  BaremineralsCheckoutId2.addEventListener('click',function(e){ 
    let fileds = document.getElementsByClassName('_NGC_CFA_note_field');
    let goNextPage = true;

    for (let a = 0; a < fileds.length; a++) {
      const item = fileds[a];
      if (document.getElementById('checknull_'+item.id)) {
        let filedsTag = item.tagName;
        let filedsType = item.type;
        let filedsValue = item.value;
        let filedsName = item.name;
        let isNullOrNot = document.getElementById('checknull_'+item.id).value;
        let errMessage = document.getElementById('errMessage_'+item.id).value;
        if ((filedsTag == "INPUT" && filedsType == "text") || filedsTag == "TEXTAREA" || filedsTag == "SELECT") {
          if((filedsValue == '' || filedsValue == '選択なし') && isNullOrNot == 'must' && errMessage !=''){
            e.preventDefault();
            document.getElementById('displayerrMessage_'+item.id).innerHTML= errMessage;
            goNextPage = false;
          } else if(isNullOrNot != 'must' && filedsValue == ''){
              if(document.getElementById(item.id)){
                document.getElementById(item.id).value = ' ';
              }            
          } else{
            document.getElementById('displayerrMessage_'+item.id).innerHTML='';
          }
        }
        if ((filedsTag == "INPUT" && filedsType == "radio") || (filedsTag == "INPUT" && filedsType == "checkbox")) {
          let els = Array.from(document.getElementsByName(filedsName));
          let rs = els.filter(el => el.checked == true);
          if(isNullOrNot == 'must' && errMessage !='' && rs.length == 0){
            e.preventDefault();   
            document.getElementById('displayerrMessage_'+item.id).innerHTML= errMessage;  
            goNextPage = false; 
          }else{
            document.getElementById('displayerrMessage_'+item.id).innerHTML='';
          }
        }
      }
    }
    if(checkDateAviliableBeforeClickingCheckOut(e) && goNextPage){
      addUpdateNGCCartAttributesToCheckOut().then(() => {
        window.location.href = '/checkout'; 
      });
    }
  })
}
if(_NCC_Shopify_Shop == 'kei-kimuchi-shop.myshopify.com' && document.querySelector('#frmSubmit')){
  document.querySelector('#frmSubmit').addEventListener('click',function(e){ 
    let fileds = document.getElementsByClassName('_NGC_CFA_note_field');
    for (let a = 0; a < fileds.length; a++) {
      const item = fileds[a];
      if (document.getElementById('checknull_'+item.id)) {
        let filedsTag = item.tagName;
        let filedsType = item.type;
        let filedsValue = item.value;
        let filedsName = item.name;
        let isNullOrNot = document.getElementById('checknull_'+item.id).value;
        let errMessage = document.getElementById('errMessage_'+item.id).value;
        if ((filedsTag == "INPUT" && filedsType == "text") || filedsTag == "TEXTAREA" || filedsTag == "SELECT") {
          if((filedsValue == '' || filedsValue == '選択なし') && isNullOrNot == 'must' && errMessage !=''){
            e.preventDefault();
            document.getElementById('displayerrMessage_'+item.id).innerHTML= errMessage;
          } else if(isNullOrNot != 'must' && filedsValue == ''){
              if(document.getElementById(item.id)){
                document.getElementById(item.id).value = ' ';
              }            
          } else{
            document.getElementById('displayerrMessage_'+item.id).innerHTML='';
          }
        }
        if ((filedsTag == "INPUT" && filedsType == "radio") || (filedsTag == "INPUT" && filedsType == "checkbox")) {
          let els = Array.from(document.getElementsByName(filedsName));
          let rs = els.filter(el => el.checked == true);
          if(isNullOrNot == 'must' && errMessage !='' && rs.length == 0){
            e.preventDefault();      
            document.getElementById('displayerrMessage_'+item.id).innerHTML= errMessage;
          }else{
            document.getElementById('displayerrMessage_'+item.id).innerHTML='';
          }
        }
      }
    }
    checkDateAviliableBeforeClickingCheckOut(e);
    addUpdateNGCCartAttributesToCheckOut();
  })
}
if((_NCC_Shopify_Theme_Name.includes('Fame') || _NCC_Shopify_Theme_Store_id == '2101') && document.querySelector('#cartCheckout')){
  document.querySelector('#cartCheckout').addEventListener('click',function(e){ 
    let fileds = document.getElementsByClassName('_NGC_CFA_note_field');
    let goNextPage = true;

    for (let a = 0; a < fileds.length; a++) {
      const item = fileds[a];
      if (document.getElementById('checknull_'+item.id)) {
        let filedsTag = item.tagName;
        let filedsType = item.type;
        let filedsValue = item.value;
        let filedsName = item.name;
        let isNullOrNot = document.getElementById('checknull_'+item.id).value;
        let errMessage = document.getElementById('errMessage_'+item.id).value;
        if ((filedsTag == "INPUT" && filedsType == "text") || filedsTag == "TEXTAREA" || filedsTag == "SELECT") {
          if((filedsValue == '' || filedsValue == '選択なし') && isNullOrNot == 'must' && errMessage !=''){
            e.preventDefault();
            document.getElementById('displayerrMessage_'+item.id).innerHTML= errMessage;
            goNextPage = false;
          } else if(isNullOrNot != 'must' && filedsValue == ''){
              if(document.getElementById(item.id)){
                document.getElementById(item.id).value = ' ';
              }            
          } else{
            document.getElementById('displayerrMessage_'+item.id).innerHTML='';
          }
        }
        if ((filedsTag == "INPUT" && filedsType == "radio") || (filedsTag == "INPUT" && filedsType == "checkbox")) {
          let els = Array.from(document.getElementsByName(filedsName));
          let rs = els.filter(el => el.checked == true);
          if(isNullOrNot == 'must' && errMessage !='' && rs.length == 0){
            e.preventDefault();      
            document.getElementById('displayerrMessage_'+item.id).innerHTML= errMessage;
            goNextPage = false;
          }else{
            document.getElementById('displayerrMessage_'+item.id).innerHTML='';
          }
        }
      }
    }
    if(checkDateAviliableBeforeClickingCheckOut(e) && goNextPage){
      addUpdateNGCCartAttributesToCheckOut().then(() => {
        window.location.href = '/checkout'; 
      });
    }
  })
}
if(_NCC_Shopify_Theme_Schema_Name ==="Eurus" && document.querySelector('#sticky-header-content')){
  const observer = new MutationObserver(() => {
    const btn = document.querySelector('#checkout-submit');
    if (btn) {
      btn.addEventListener('click',function(e){ 
        let fileds = document.getElementsByClassName('_NGC_CFA_note_field');
        let goNextPage = true;
        for (let a = 0; a < fileds.length; a++) {
          const item = fileds[a];
          if (document.getElementById('checknull_'+item.id)) {
            let filedsTag = item.tagName;
            let filedsType = item.type;
            let filedsValue = item.value;
            let filedsName = item.name;
            let isNullOrNot = document.getElementById('checknull_'+item.id).value;
            let errMessage = document.getElementById('errMessage_'+item.id).value;
            if ((filedsTag == "INPUT" && filedsType == "text") || filedsTag == "TEXTAREA" || filedsTag == "SELECT") {
              if((filedsValue == '' || filedsValue == '選択なし') && isNullOrNot == 'must' && errMessage !=''){
                e.preventDefault();
                document.getElementById('displayerrMessage_'+item.id).innerHTML= errMessage;
                goNextPage = false;
              } else if(isNullOrNot != 'must' && filedsValue == ''){
                  if(document.getElementById(item.id)){
                    document.getElementById(item.id).value = ' ';
                  }            
              } else{
                document.getElementById('displayerrMessage_'+item.id).innerHTML='';
              }
            }
            if ((filedsTag == "INPUT" && filedsType == "radio") || (filedsTag == "INPUT" && filedsType == "checkbox")) {
              let els = Array.from(document.getElementsByName(filedsName));
              let rs = els.filter(el => el.checked == true);
              if(isNullOrNot == 'must' && errMessage !='' && rs.length == 0){
                e.preventDefault();      
                document.getElementById('displayerrMessage_'+item.id).innerHTML= errMessage;
                goNextPage = false;
              }else{
                document.getElementById('displayerrMessage_'+item.id).innerHTML='';
              }
            }
          }
        }
        if(checkDateAviliableBeforeClickingCheckOut(e) && goNextPage){
          addUpdateNGCCartAttributesToCheckOut().then(() => {
            window.location.href = '/checkout'; 
          });
        }
      })
      document.querySelector('#ngc_haisou_modal')?.addEventListener('click', (e) => {
        e.stopPropagation();
      });
      observer.disconnect();
    }
  });
  observer.observe(document.querySelector('#sticky-header-content'), { childList: true, subtree: true });
}
